/***********************************************************************

  File:   cfg_test_x.v
  Rev:    5.0.0

  This is the user configurable options file for Xilinx's PCIX LogiCORE.
  This file is normally generated by the CORE Generator tool.

  Copyright (c) 2003 Xilinx, Inc.  All rights reserved.

***********************************************************************/


// Declare literals for use later.

`define DISABLE         1'b0
`define ENABLE          1'b1


// Declare the module.

module CFG (CFG);


  // Declare the port directions.

  output [511:0] CFG;


  /*************************************************************/
  /* Constant fields in configuration space.                   */
  /*************************************************************/

  // Vendor Identification.
  assign CFG[ 15:  0] = 16'h10ee;

  // Device Identification.
  //assign CFG[ 31: 16] = 16'h1000;
  assign CFG[ 31: 16] = 16'h0500;    //Memory Controller DeviceID

  // Revision Identification.
  assign CFG[ 39: 32] = 8'h00;

  // Class Code.
  assign CFG[ 63: 40] = 24'h05_00_00; //RAM memory controller

  // Cardbus CIS Pointer.
  assign CFG[287:256] = 32'h00000000;

  // Subvendor Identification.
  assign CFG[303:288] = 16'h10ee;

  // Subsystem Identification.
  assign CFG[319:304] = 16'h0500; 

  // Capabilities Pointer.
  assign CFG[359:352] = 8'h40;

  // Minimum Grant.
  assign CFG[367:360] = 8'h00;

  // Maximum Latency.
  assign CFG[375:368] = 8'h00;

  // PCI Device 66 MHz Capable.
  assign CFG[480] = 1'b0;

  // PCI Device Decode Speed.
  assign CFG[482:481] = 2'b10;


  /*************************************************************/
  /* Power management in extended config space, 40h.           */
  /*************************************************************/

  // Power Management Next Pointer.
  assign CFG[383:376] = 8'h48;

  // Support State D1.
  assign CFG[483] = 1'b0;

  // Support State D2.
  assign CFG[484] = 1'b0;

  // Support Soft Reset.
  assign CFG[485] = 1'b1;


  /*************************************************************/
  /* Message signaled interrupts in extended config space, 48h.*/
  /*************************************************************/

  // Message Signaled Interrupts Next Pointer.
  assign CFG[391:384] = 8'h58;

  // Multiple Message Capable Bit 0.
  assign CFG[486] = 1'b0;

  // Multiple Message Capable Bit 1.
  assign CFG[487] = 1'b0;

  // Multiple Message Capable Bit 2.
  assign CFG[488] = 1'b0;


  /*************************************************************/
  /* PCI-X capabilities in extended config space, 58h.         */
  /*************************************************************/

  // PCI-X Next Pointer.
  assign CFG[399:392] = 8'h00;

  // PCI-X Interface Design Information.
  assign CFG[407:400] = 8'b00000000;

  // PCI-X Device 64-Bit.
  assign CFG[489] = 1'b1;

  // PCI-X Device 133 MHz Capable.
  assign CFG[490] = 1'b1;   //was 1'b1

  // PCI-X Device Complex.
  assign CFG[491] = 1'b0;

  // PCI-X Max Outstanding Split Command Register Bit 0. 
  assign CFG[496] = 1'b0;

  // PCI-X Max Outstanding Split Command Register Bit 1.
  assign CFG[498] = 1'b0;

  // PCI-X Max Outstanding Split Command Register Bit 2.
  assign CFG[499] = 1'b0;


  /*************************************************************/
  /* Generic target address space configuration.               */
  /*************************************************************/

  // BAR0.
  assign CFG[ 95: 64] = 32'h00000000;//kl was ffff0001
  assign CFG[408] = 1'b0;

  // BAR1.
  assign CFG[127: 96] = 32'h00000000;
  assign CFG[409] = 1'b0;

  // BAR2. (128MB memory, prefetchable, 64-bit address, 64-bit data)
  assign CFG[159:128] = 32'hf8000004;
  assign CFG[410] = 1'b1;

  // BAR3. (Paired with BAR2 for 64 bit address space)
  assign CFG[191:160] = 32'hffffffff;
  assign CFG[411] = 1'b1;

  // BAR4.
  assign CFG[223:192] = 32'h00000000;
  assign CFG[412] = 1'b0;

  // BAR5.
  assign CFG[255:224] = 32'h00000000;
  assign CFG[413] = 1'b0;

  // Expansion ROM BAR.
  assign CFG[351:320] = 32'h00000000;
  assign CFG[414] = 1'b0;

  // Split Transaction Target.
  assign CFG[415] = 1'b0;


  /*************************************************************/
  /* Special target address space configuration options.       */
  /*************************************************************/

  // Autoconfigure BAR0.
  assign CFG[492] = 1'b0;
  assign CFG[447:416] = 32'h00000000;

  // Autoconfigure BAR1.
  assign CFG[493] = 1'b0;
  assign CFG[479:448] = 32'h00000000;

  // Enable Instant On.
  assign CFG[494] = 1'b0;
  assign CFG[501] = 1'b0;

  // Enable Interrupt Acknowledge.
  assign CFG[495] = 1'b0;

  // Enable User Configuration Space.
  assign CFG[497] = 1'b0;
  

  /*************************************************************/
  /* Reserved configuration.                                   */
  /*************************************************************/

  // Reserved, Unused.
  assign CFG[500] = 1'b0;
  assign CFG[502] = 1'b0;
  assign CFG[503] = 1'b0;
  assign CFG[504] = 1'b1;
  assign CFG[505] = 1'b0;
  assign CFG[506] = 1'b0;
  assign CFG[507] = 1'b1;
  assign CFG[508] = 1'b0;
  assign CFG[509] = 1'b0;
  assign CFG[510] = 1'b0;
  assign CFG[511] = 1'b0;


  /*************************************************************/
  /*                                                           */
  /*************************************************************/


endmodule
