// counter values in the controller in tCK units (clock period = 5 ns)
// write latency (WL) = Read Latency (RL) - 1 = AL + CL -1 = 0 + 4 - 1 = 3
// Read Latency (RL ) = AL + CL = 4
`timescale 1ns/100ps 
// Load Mode register parameters
`define cas_latency_value      3'b011 //KL 3'b101    // (2,3,4,5)
`define burst_length           3'b010    // can be 2, 4 or 8 for DDR //Olivier 10_25//
`define data_width_config      8    // can be x4, x8 or x16
`define write_recovery_value   2    // canbe 2,3,4,5,6

`define rcd_count_value        2'b01    // Active to Read/Write = tRCD -1
`define rc_count_value         4'b1111   // active to active same bank = tRC-1

`define mrd_count_value        1'b1    // Load Mode command cycle time = tMRD -1
`define rp_count_value         2'b11    // Precharge command period = tRP -1
`define rfc_count_value        5'b10011   // Auto Refresh command period = tRFC -1 

`define ras_count_value        4'b1011   // active to precharge = tras - 1
`define rtp_count_value        2'b01    // read to precharge = (AL + BL/2 + tRTP - 2) = (0+ BL/2 + 2 - 2) -1
                                    // = (1 (for BL=4)/ 3(for BL=8))
`define wtp_count_value          4'b1000    // write to precharge = (WL + BL/2 + tWR ) = (3+BL/2+4) -1
                                    // = (8 (for BL=4)/ 10(for BL=8))   
`define wr_to_rd_count_value   4'b0110    // write to read command time = (WL + BL/2 + tWTR) - 1 = (3+BL/2 + 2) -1
                                    // = (6 (for Bl =4)/ 8(for BL=8))
`define max_ref_cnt            8'h60 //use 60 = 11.52 which is less than 15.6(requirement) - 4.0 (4K burst) 
                                     //to guarantee that I always meet the requirement; even if doing a 4K burst ; 
			             //refresh requirement for 128MB is 15.6 us 
                     
`define Phy_Mode              1'b1    // 1- direct clocking, 0- local clocking                                     
                                        
//`define rrd_count_value    2  //Active bank a to bank b command  
//`define ddr2_address       4'h13                                                                                                                                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                                                                                                              
                                                                                                                                                                                                                                                                                                                                                              
