/***********************************************************************

  File:   pcix_lc.v
  Rev:    5.0.0

  This is a lower-level Verilog module which serves as a wrapper
  for the PCIX interface.  This module makes use of Unified Library
  Primitives.  Do not modify this file.

  Copyright (c) 2006 Xilinx, Inc.  All rights reserved.

***********************************************************************/
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
//              provided to you "as is". Xilinx and its licensors make and you 
//              receive no warranties or conditions, express, implied, 
//              statutory or otherwise, and Xilinx specifically disclaims any 
//              implied warranties of merchantability, non-infringement, or 
//              fitness for a particular purpose. Xilinx does not warrant that 
//              the functions contained in these designs will meet your 
//              requirements, or that the operation of these designs will be 
//              uninterrupted or error free, or that defects in the Designs 
//              will be corrected. Furthermore, Xilinx does not warrant or 
//              make any representations regarding use or the results of the 
//              use of the designs in terms of correctness, accuracy, 
//              reliability, or otherwise. 
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its 
//              licensors be liable for any loss of data, lost profits, cost 
//              or procurement of substitute goods or services, or for any 
//              special, incidental, consequential, or indirect damages 
//              arising from the use or operation of the designs or 
//              accompanying documentation, however caused and on any theory 
//              of liability. This limitation will apply even if Xilinx 
//              has been advised of the possibility of such damage. This 
//              limitation shall apply not-withstanding the failure of the 
//              essential purpose of any limited remedies herein. 
//
//  Copyright  2006 Xilinx, Inc.
//  All rights reserved 
// 
//*****************************************************************************


// Declare the module.

module PCIX_LC  (
                AD_IO,
                CBE_IO,
                PAR_IO,
                PAR64_IO,
                FRAME_IO,
                REQ64_IO,
                TRDY_IO,
                IRDY_IO,
                STOP_IO,
                DEVSEL_IO,
                ACK64_IO,
                IDSEL_I,
                PERR_IO,
                SERR_IO,
                INT_O,
                PME_O,
                REQ_O,
                GNT_I,
                RST_I,
                CLK_I,
                S_DATA_OUT,
                S_CBEA_OUT,
                S_DATA_IN,
                S_ADDL_VLD,
                S_ADDH_VLD,
                S_ATTR_VLD,
                S_DATL_VLD,
                S_DATH_VLD,
                S_DATA_NXT,
                S_TABORT,
                S_RETRY,
                S_DISCON,
                S_NXTADB,
                S_WAIT,
                S_SPLIT,
                S_WRITE,
                S_DONE,
                S_HIT,
                M_DATA_OUT,
                M_CBEA_IN,
                M_DATA_IN,
                M_ADDL_VLD,
                M_ADDH_VLD,
                M_ATTR_VLD,
                M_DATL_VLD,
                M_DATH_VLD,
                M_DATA_NXT,
                M_MABORT,
                M_RETRY,
                M_NXTADB,
                M_DISCON,
                M_TABORT,
                M_SPLIT,
                M_FINISH,
                M_DONE,
                M_REQ,
                PERR_N,
                SERR_N,
                INT_N,
                MS_STAT,
                PME_N,
                PM_STAT,
                CSR,
                CSR_SYSTEMERR_N, 
                CSRX_UNEXPECTED, 
                CSRX_DISCARDED, 
                CSRX,
                PCIW_EN,
                PCIX_EN,
                RTR,
                CFG,
                RST,
                CLK,
                CLK90,
                CLKDIV,
                DCM_LOCK
                );
                // synthesis syn_edif_bit_format = "%u<%i>"
                // synthesis syn_edif_scalar_format = "%u"
                // synthesis syn_noclockbuf = 1 
                // synthesis syn_hier = "hard" 


  // Declare the port directions.

  inout  [63:0] AD_IO;
  inout   [7:0] CBE_IO;
  inout         PAR_IO;
  inout         PAR64_IO;
  inout         FRAME_IO;
  inout         REQ64_IO;
  inout         TRDY_IO;
  inout         IRDY_IO;
  inout         STOP_IO;
  inout         DEVSEL_IO;
  inout         ACK64_IO;
  input         IDSEL_I;
  inout         PERR_IO;
  inout         SERR_IO;
  output        INT_O;
  output        PME_O;
  output        REQ_O;
  input         GNT_I;
  input         RST_I;
  input         CLK_I;
  output [63:0] S_DATA_OUT;
  output  [7:0] S_CBEA_OUT;
  input  [63:0] S_DATA_IN;
  output        S_ADDL_VLD;
  output        S_ADDH_VLD;
  output        S_ATTR_VLD;
  output        S_DATL_VLD;
  output        S_DATH_VLD;
  output        S_DATA_NXT;
  input         S_TABORT;
  input         S_RETRY;
  input         S_DISCON;
  input         S_NXTADB;
  input         S_WAIT;
  input         S_SPLIT;
  output        S_WRITE;
  output        S_DONE;
  output [15:0] S_HIT;
  output [63:0] M_DATA_OUT;
  input   [7:0] M_CBEA_IN;
  input  [63:0] M_DATA_IN;
  output        M_ADDL_VLD;
  output        M_ADDH_VLD;
  output        M_ATTR_VLD;
  output        M_DATL_VLD;
  output        M_DATH_VLD;
  output        M_DATA_NXT;
  output        M_MABORT;
  output        M_RETRY;
  output        M_NXTADB;
  output        M_DISCON;
  output        M_TABORT;
  output        M_SPLIT;
  input         M_FINISH;
  output        M_DONE;
  input         M_REQ;
  output        PERR_N;
  output        SERR_N;
  input         INT_N;
  output [95:0] MS_STAT;
  input         PME_N;
  output [47:0] PM_STAT;
  output [31:0] CSR;
  input         CSR_SYSTEMERR_N; 
  input         CSRX_UNEXPECTED;
  input         CSRX_DISCARDED;
  output [47:0] CSRX;
  output        PCIW_EN;
  output        PCIX_EN;
  output        RTR;
  input [511:0] CFG;
  output        RST;
  inout         CLK;
  output        CLK90;
  output        CLKDIV;
  output        DCM_LOCK;

  // I/O instances for clock, reset, power, and ground.

  wire          RST_INV;
  wire          BUS_RST;
  wire          CLK_NUB;
  wire          CLK_OUT;
  wire          BYP;
  wire          LCK;
  wire          LO;
  wire          HI;
  wire          NC90, NC180, NC270;
  wire          NC2X, NCDV, NCLCK;
  wire          CLK90_OUT, CLKDIV_OUT;
  
IBUFG_PCIX XPCI_CLK1 (.O(CLK_NUB),.I(CLK_I));
assign DCM_LOCK = LCK;
// synthesis translate_off
defparam XPCI_DLL.DLL_FREQUENCY_MODE = "LOW";
defparam XPCI_DLL.DUTY_CYCLE_CORRECTION = "TRUE";
defparam XPCI_DLL.CLKDV_DIVIDE = 16.0;
// synthesis translate_on
//synthesis attribute DLL_FREQUENCY_MODE of XPCI_DLL is "LOW"
//synthesis attribute DUTY_CYCLE_CORRECTION of XPCI_DLL is "TRUE"
//synthesis attribute CLKDV_DIVIDE of XPCI_DLL is "16.0"
  DCM_BASE XPCI_DLL (.CLKIN(CLK_NUB), .CLKFB(CLK), .RST(BUS_RST), .CLK0(CLK_OUT),
                   .CLK90(CLK90_OUT), .CLK180(NC180), .CLK270(NC270),
                   .CLK2X(NC2X), .CLKDV(CLKDIV_OUT),
                   .LOCKED(NCLCK))/*synthesis xc_props="DLL_FREQUENCY_MODE = LOW,DUTY_CYCLE_CORRECTION = TRUE,CLKDV_DIVIDE = 16.0" */;
  BUFG       XPCI_CLK2 (.O(CLK),.I(CLK_OUT));
  IBUF_PCIX  XPCI_RST1 (.O(RST_INV),.I(RST_I));
  INV        XPCI_RST2 (.O(BUS_RST),.I(RST_INV));
  BUFG       DDR_CLK90 (.O(CLK90),.I(CLK90_OUT));
  BUFG       DDR_CLKDIV (.O(CLKDIV),.I(CLKDIV_OUT));
  
  assign LCK = NCLCK;
  assign LO = 1'b0;
  assign HI = 1'b1;

   
  // I/O instances for address and data.

  wire   [63:0] ADO;
  wire   [63:0] ADI;
  wire   [63:0] ADT;

  IOBUF_PCIX XPCI_AD63 (.O(ADI[63]),.IO(AD_IO[63]),.I(ADO[63]),.T(ADT[63]));
  IOBUF_PCIX XPCI_AD62 (.O(ADI[62]),.IO(AD_IO[62]),.I(ADO[62]),.T(ADT[62]));
  IOBUF_PCIX XPCI_AD61 (.O(ADI[61]),.IO(AD_IO[61]),.I(ADO[61]),.T(ADT[61]));
  IOBUF_PCIX XPCI_AD60 (.O(ADI[60]),.IO(AD_IO[60]),.I(ADO[60]),.T(ADT[60]));
  IOBUF_PCIX XPCI_AD59 (.O(ADI[59]),.IO(AD_IO[59]),.I(ADO[59]),.T(ADT[59]));
  IOBUF_PCIX XPCI_AD58 (.O(ADI[58]),.IO(AD_IO[58]),.I(ADO[58]),.T(ADT[58]));
  IOBUF_PCIX XPCI_AD57 (.O(ADI[57]),.IO(AD_IO[57]),.I(ADO[57]),.T(ADT[57]));
  IOBUF_PCIX XPCI_AD56 (.O(ADI[56]),.IO(AD_IO[56]),.I(ADO[56]),.T(ADT[56]));

  IOBUF_PCIX XPCI_AD55 (.O(ADI[55]),.IO(AD_IO[55]),.I(ADO[55]),.T(ADT[55]));
  IOBUF_PCIX XPCI_AD54 (.O(ADI[54]),.IO(AD_IO[54]),.I(ADO[54]),.T(ADT[54]));
  IOBUF_PCIX XPCI_AD53 (.O(ADI[53]),.IO(AD_IO[53]),.I(ADO[53]),.T(ADT[53]));
  IOBUF_PCIX XPCI_AD52 (.O(ADI[52]),.IO(AD_IO[52]),.I(ADO[52]),.T(ADT[52]));
  IOBUF_PCIX XPCI_AD51 (.O(ADI[51]),.IO(AD_IO[51]),.I(ADO[51]),.T(ADT[51]));
  IOBUF_PCIX XPCI_AD50 (.O(ADI[50]),.IO(AD_IO[50]),.I(ADO[50]),.T(ADT[50]));
  IOBUF_PCIX XPCI_AD49 (.O(ADI[49]),.IO(AD_IO[49]),.I(ADO[49]),.T(ADT[49]));
  IOBUF_PCIX XPCI_AD48 (.O(ADI[48]),.IO(AD_IO[48]),.I(ADO[48]),.T(ADT[48]));

  IOBUF_PCIX XPCI_AD47 (.O(ADI[47]),.IO(AD_IO[47]),.I(ADO[47]),.T(ADT[47]));
  IOBUF_PCIX XPCI_AD46 (.O(ADI[46]),.IO(AD_IO[46]),.I(ADO[46]),.T(ADT[46]));
  IOBUF_PCIX XPCI_AD45 (.O(ADI[45]),.IO(AD_IO[45]),.I(ADO[45]),.T(ADT[45]));
  IOBUF_PCIX XPCI_AD44 (.O(ADI[44]),.IO(AD_IO[44]),.I(ADO[44]),.T(ADT[44]));
  IOBUF_PCIX XPCI_AD43 (.O(ADI[43]),.IO(AD_IO[43]),.I(ADO[43]),.T(ADT[43]));
  IOBUF_PCIX XPCI_AD42 (.O(ADI[42]),.IO(AD_IO[42]),.I(ADO[42]),.T(ADT[42]));
  IOBUF_PCIX XPCI_AD41 (.O(ADI[41]),.IO(AD_IO[41]),.I(ADO[41]),.T(ADT[41]));
  IOBUF_PCIX XPCI_AD40 (.O(ADI[40]),.IO(AD_IO[40]),.I(ADO[40]),.T(ADT[40]));

  IOBUF_PCIX XPCI_AD39 (.O(ADI[39]),.IO(AD_IO[39]),.I(ADO[39]),.T(ADT[39]));
  IOBUF_PCIX XPCI_AD38 (.O(ADI[38]),.IO(AD_IO[38]),.I(ADO[38]),.T(ADT[38]));
  IOBUF_PCIX XPCI_AD37 (.O(ADI[37]),.IO(AD_IO[37]),.I(ADO[37]),.T(ADT[37]));
  IOBUF_PCIX XPCI_AD36 (.O(ADI[36]),.IO(AD_IO[36]),.I(ADO[36]),.T(ADT[36]));
  IOBUF_PCIX XPCI_AD35 (.O(ADI[35]),.IO(AD_IO[35]),.I(ADO[35]),.T(ADT[35]));
  IOBUF_PCIX XPCI_AD34 (.O(ADI[34]),.IO(AD_IO[34]),.I(ADO[34]),.T(ADT[34]));
  IOBUF_PCIX XPCI_AD33 (.O(ADI[33]),.IO(AD_IO[33]),.I(ADO[33]),.T(ADT[33]));
  IOBUF_PCIX XPCI_AD32 (.O(ADI[32]),.IO(AD_IO[32]),.I(ADO[32]),.T(ADT[32]));

  IOBUF_PCIX XPCI_AD31 (.O(ADI[31]),.IO(AD_IO[31]),.I(ADO[31]),.T(ADT[31]));
  IOBUF_PCIX XPCI_AD30 (.O(ADI[30]),.IO(AD_IO[30]),.I(ADO[30]),.T(ADT[30]));
  IOBUF_PCIX XPCI_AD29 (.O(ADI[29]),.IO(AD_IO[29]),.I(ADO[29]),.T(ADT[29]));
  IOBUF_PCIX XPCI_AD28 (.O(ADI[28]),.IO(AD_IO[28]),.I(ADO[28]),.T(ADT[28]));
  IOBUF_PCIX XPCI_AD27 (.O(ADI[27]),.IO(AD_IO[27]),.I(ADO[27]),.T(ADT[27]));
  IOBUF_PCIX XPCI_AD26 (.O(ADI[26]),.IO(AD_IO[26]),.I(ADO[26]),.T(ADT[26]));
  IOBUF_PCIX XPCI_AD25 (.O(ADI[25]),.IO(AD_IO[25]),.I(ADO[25]),.T(ADT[25]));
  IOBUF_PCIX XPCI_AD24 (.O(ADI[24]),.IO(AD_IO[24]),.I(ADO[24]),.T(ADT[24]));

  IOBUF_PCIX XPCI_AD23 (.O(ADI[23]),.IO(AD_IO[23]),.I(ADO[23]),.T(ADT[23]));
  IOBUF_PCIX XPCI_AD22 (.O(ADI[22]),.IO(AD_IO[22]),.I(ADO[22]),.T(ADT[22]));
  IOBUF_PCIX XPCI_AD21 (.O(ADI[21]),.IO(AD_IO[21]),.I(ADO[21]),.T(ADT[21]));
  IOBUF_PCIX XPCI_AD20 (.O(ADI[20]),.IO(AD_IO[20]),.I(ADO[20]),.T(ADT[20]));
  IOBUF_PCIX XPCI_AD19 (.O(ADI[19]),.IO(AD_IO[19]),.I(ADO[19]),.T(ADT[19]));
  IOBUF_PCIX XPCI_AD18 (.O(ADI[18]),.IO(AD_IO[18]),.I(ADO[18]),.T(ADT[18]));
  IOBUF_PCIX XPCI_AD17 (.O(ADI[17]),.IO(AD_IO[17]),.I(ADO[17]),.T(ADT[17]));
  IOBUF_PCIX XPCI_AD16 (.O(ADI[16]),.IO(AD_IO[16]),.I(ADO[16]),.T(ADT[16]));

  IOBUF_PCIX XPCI_AD15 (.O(ADI[15]),.IO(AD_IO[15]),.I(ADO[15]),.T(ADT[15]));
  IOBUF_PCIX XPCI_AD14 (.O(ADI[14]),.IO(AD_IO[14]),.I(ADO[14]),.T(ADT[14]));
  IOBUF_PCIX XPCI_AD13 (.O(ADI[13]),.IO(AD_IO[13]),.I(ADO[13]),.T(ADT[13]));
  IOBUF_PCIX XPCI_AD12 (.O(ADI[12]),.IO(AD_IO[12]),.I(ADO[12]),.T(ADT[12]));
  IOBUF_PCIX XPCI_AD11 (.O(ADI[11]),.IO(AD_IO[11]),.I(ADO[11]),.T(ADT[11]));
  IOBUF_PCIX XPCI_AD10 (.O(ADI[10]),.IO(AD_IO[10]),.I(ADO[10]),.T(ADT[10]));
  IOBUF_PCIX XPCI_AD9  (.O(ADI[ 9]),.IO(AD_IO[ 9]),.I(ADO[ 9]),.T(ADT[ 9]));
  IOBUF_PCIX XPCI_AD8  (.O(ADI[ 8]),.IO(AD_IO[ 8]),.I(ADO[ 8]),.T(ADT[ 8]));

  IOBUF_PCIX XPCI_AD7  (.O(ADI[ 7]),.IO(AD_IO[ 7]),.I(ADO[ 7]),.T(ADT[ 7]));
  IOBUF_PCIX XPCI_AD6  (.O(ADI[ 6]),.IO(AD_IO[ 6]),.I(ADO[ 6]),.T(ADT[ 6]));
  IOBUF_PCIX XPCI_AD5  (.O(ADI[ 5]),.IO(AD_IO[ 5]),.I(ADO[ 5]),.T(ADT[ 5]));
  IOBUF_PCIX XPCI_AD4  (.O(ADI[ 4]),.IO(AD_IO[ 4]),.I(ADO[ 4]),.T(ADT[ 4]));
  IOBUF_PCIX XPCI_AD3  (.O(ADI[ 3]),.IO(AD_IO[ 3]),.I(ADO[ 3]),.T(ADT[ 3]));
  IOBUF_PCIX XPCI_AD2  (.O(ADI[ 2]),.IO(AD_IO[ 2]),.I(ADO[ 2]),.T(ADT[ 2]));
  IOBUF_PCIX XPCI_AD1  (.O(ADI[ 1]),.IO(AD_IO[ 1]),.I(ADO[ 1]),.T(ADT[ 1]));
  IOBUF_PCIX XPCI_AD0  (.O(ADI[ 0]),.IO(AD_IO[ 0]),.I(ADO[ 0]),.T(ADT[ 0]));


  // I/O instances for command and byte enable.

  wire    [7:0] CBO;
  wire    [7:0] CBI;
  wire    [7:0] CBT;

  IOBUF_PCIX XPCI_CB7 (.O(CBI[ 7]),.IO(CBE_IO[ 7]),.I(CBO[ 7]),.T(CBT[ 7]));
  IOBUF_PCIX XPCI_CB6 (.O(CBI[ 6]),.IO(CBE_IO[ 6]),.I(CBO[ 6]),.T(CBT[ 6]));
  IOBUF_PCIX XPCI_CB5 (.O(CBI[ 5]),.IO(CBE_IO[ 5]),.I(CBO[ 5]),.T(CBT[ 5]));
  IOBUF_PCIX XPCI_CB4 (.O(CBI[ 4]),.IO(CBE_IO[ 4]),.I(CBO[ 4]),.T(CBT[ 4]));

  IOBUF_PCIX XPCI_CB3 (.O(CBI[ 3]),.IO(CBE_IO[ 3]),.I(CBO[ 3]),.T(CBT[ 3]));
  IOBUF_PCIX XPCI_CB2 (.O(CBI[ 2]),.IO(CBE_IO[ 2]),.I(CBO[ 2]),.T(CBT[ 2]));
  IOBUF_PCIX XPCI_CB1 (.O(CBI[ 1]),.IO(CBE_IO[ 1]),.I(CBO[ 1]),.T(CBT[ 1]));
  IOBUF_PCIX XPCI_CB0 (.O(CBI[ 0]),.IO(CBE_IO[ 0]),.I(CBO[ 0]),.T(CBT[ 0]));


  // I/O instances for parity.

  wire          PARO;
  wire          PARI;
  wire          PART;

  wire          PAR64O;
  wire          PAR64I;
  wire          PAR64T;

  IOBUF_PCIX XPCI_PAR   (.O(PARI),  .IO(PAR_IO),  .I(PARO),  .T(PART  ));
  IOBUF_PCIX XPCI_PAR64 (.O(PAR64I),.IO(PAR64_IO),.I(PAR64O),.T(PAR64T));


  // I/O instances for control.

  wire          FRAMEO;
  wire          FRAMEI;
  wire          FRAMET;

  wire          REQ64O;
  wire          REQ64I;
  wire          REQ64T;

  wire          TRDYO;
  wire          TRDYI;
  wire          TRDYT;

  wire          IRDYO;
  wire          IRDYI;
  wire          IRDYT;

  wire          STOPO;
  wire          STOPI;
  wire          STOPT;

  wire          DEVSELO;
  wire          DEVSELI;
  wire          DEVSELT;

  wire          ACK64O;
  wire          ACK64I;
  wire          ACK64T;

  wire          PERRO;
  wire          PERRI;
  wire          PERRT;

  wire          SERRO;
  wire          SERRI;
  wire          SERRT;

  wire          INTO;
  wire          INTT;

  wire          PMEO;
  wire          PMET;

  wire          REQO;
  wire          REQT;

  wire          GNTI;

  wire          IDSELI;

  IOBUF_PCIX XPCI_FRAME (.O(FRAMEI), .IO(FRAME_IO), .I(FRAMEO), .T(FRAMET) );
  IOBUF_PCIX XPCI_REQ64 (.O(REQ64I), .IO(REQ64_IO), .I(REQ64O), .T(REQ64T) );
  IOBUF_PCIX XPCI_TRDY  (.O(TRDYI),  .IO(TRDY_IO),  .I(TRDYO),  .T(TRDYT)  );
  IOBUF_PCIX XPCI_IRDY  (.O(IRDYI),  .IO(IRDY_IO),  .I(IRDYO),  .T(IRDYT)  );
  IOBUF_PCIX XPCI_STOP  (.O(STOPI),  .IO(STOP_IO),  .I(STOPO),  .T(STOPT)  );
  IOBUF_PCIX XPCI_DEVSEL(.O(DEVSELI),.IO(DEVSEL_IO),.I(DEVSELO),.T(DEVSELT));
  IOBUF_PCIX XPCI_ACK64 (.O(ACK64I), .IO(ACK64_IO), .I(ACK64O), .T(ACK64T) );
  IOBUF_PCIX XPCI_PERR  (.O(PERRI),  .IO(PERR_IO),  .I(PERRO),  .T(PERRT)  );
  IOBUF_PCIX XPCI_SERR  (.O(SERRI),  .IO(SERR_IO),  .I(SERRO),  .T(SERRT)  );

  OBUFT_PCIX XPCI_INT   (.O(INT_O),.T(INTT),.I(INTO));
  OBUFT_PCIX XPCI_PME   (.O(PME_O),.T(PMET),.I(PMEO));
  OBUFT_PCIX XPCI_REQ   (.O(REQ_O),.T(REQT),.I(REQO));

  IBUF_PCIX  XPCI_GNT   (.O(GNTI),.I(GNT_I));
  IBUF_PCIX  XPCI_IDSEL (.O(IDSELI),.I(IDSEL_I));


  // Instantiate PCIX interface.

  PCIX_CORE XPCI_CORE (
                .ADO(ADO),
                .ADI(ADI),
                .ADT(ADT),
                .CBO(CBO),
                .CBI(CBI),
                .CBT(CBT),
                .PARO(PARO),
                .PARI(PARI),
                .PART(PART),
                .PAR64O(PAR64O),
                .PAR64I(PAR64I),
                .PAR64T(PAR64T),
                .FRAMEO(FRAMEO),
                .FRAMEI(FRAMEI),
                .FRAMET(FRAMET),
                .REQ64O(REQ64O),
                .REQ64I(REQ64I),
                .REQ64T(REQ64T),
                .TRDYO(TRDYO),
                .TRDYI(TRDYI),
                .TRDYT(TRDYT),
                .IRDYO(IRDYO),
                .IRDYI(IRDYI),
                .IRDYT(IRDYT),
                .STOPO(STOPO),
                .STOPI(STOPI),
                .STOPT(STOPT),
                .DEVSELO(DEVSELO),
                .DEVSELI(DEVSELI),
                .DEVSELT(DEVSELT),
                .ACK64O(ACK64O),
                .ACK64I(ACK64I),
                .ACK64T(ACK64T),
                .PERRO(PERRO),
                .PERRI(PERRI),
                .PERRT(PERRT),
                .SERRO(SERRO),
                .SERRI(SERRI),
                .SERRT(SERRT),
                .INTO(INTO),
                .INTT(INTT),
                .PMEO(PMEO),
                .PMET(PMET),
                .REQO(REQO),
                .REQT(REQT),
                .GNTI(GNTI),
                .IDSELI(IDSELI),
                .S_DATA_OUT(S_DATA_OUT),
                .S_CBEA_OUT(S_CBEA_OUT),
                .S_DATA_IN(S_DATA_IN),
                .S_ADDL_VLD(S_ADDL_VLD),
                .S_ADDH_VLD(S_ADDH_VLD),
                .S_ATTR_VLD(S_ATTR_VLD),
                .S_DATL_VLD(S_DATL_VLD),
                .S_DATH_VLD(S_DATH_VLD),
                .S_DATA_NXT(S_DATA_NXT),
                .S_TABORT(S_TABORT),
                .S_RETRY(S_RETRY),
                .S_DISCON(S_DISCON),
                .S_NXTADB(S_NXTADB),
                .S_WAIT(S_WAIT),
                .S_SPLIT(S_SPLIT),
                .S_WRITE(S_WRITE),
                .S_DONE(S_DONE),
                .S_HIT(S_HIT),
                .M_DATA_OUT(M_DATA_OUT),
                .M_CBEA_IN(M_CBEA_IN),
                .M_DATA_IN(M_DATA_IN),
                .M_ADDL_VLD(M_ADDL_VLD),
                .M_ADDH_VLD(M_ADDH_VLD),
                .M_ATTR_VLD(M_ATTR_VLD),
                .M_DATL_VLD(M_DATL_VLD),
                .M_DATH_VLD(M_DATH_VLD),
                .M_DATA_NXT(M_DATA_NXT),
                .M_MABORT(M_MABORT),
                .M_RETRY(M_RETRY),
                .M_NXTADB(M_NXTADB),
                .M_DISCON(M_DISCON),
                .M_TABORT(M_TABORT),
                .M_SPLIT(M_SPLIT),
                .M_FINISH(M_FINISH),
                .M_DONE(M_DONE),
                .M_REQ(M_REQ),
                .PERR_N(PERR_N),
                .SERR_N(SERR_N),
                .INT_N(INT_N),
                .MS_STAT(MS_STAT),
                .PME_N(PME_N),
                .PM_STAT(PM_STAT),
                .CSR(CSR),
                .CSR_SYSTEMERR_N(CSR_SYSTEMERR_N),
                .CSRX_UNEXPECTED(CSRX_UNEXPECTED),
                .CSRX_DISCARDED(CSRX_DISCARDED), 
                .CSRX(CSRX),
                .PCIW_EN(PCIW_EN),
                .PCIX_EN(PCIX_EN),
                .BUS_RST(BUS_RST),
                .RTR(RTR),
                .CFG(CFG),
                .RST(RST),
                .BYP(BYP),
                .LCK(LCK),
                .CLK(CLK)
  );


endmodule

