/***********************************************************************

  File:   pcix_top.v
  Rev:    5.0.0

  This is the top-level template file for Verilog designs.
  The user should place his backend application design in the
  userapp module.

  Copyright (c) 2003 Xilinx, Inc.  All rights reserved.

***********************************************************************/
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
//              provided to you "as is". Xilinx and its licensors make and you 
//              receive no warranties or conditions, express, implied, 
//              statutory or otherwise, and Xilinx specifically disclaims any 
//              implied warranties of merchantability, non-infringement, or 
//              fitness for a particular purpose. Xilinx does not warrant that 
//              the functions contained in these designs will meet your 
//              requirements, or that the operation of these designs will be 
//              uninterrupted or error free, or that defects in the Designs 
//              will be corrected. Furthermore, Xilinx does not warrant or 
//              make any representations regarding use or the results of the 
//              use of the designs in terms of correctness, accuracy, 
//              reliability, or otherwise. 
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its 
//              licensors be liable for any loss of data, lost profits, cost 
//              or procurement of substitute goods or services, or for any 
//              special, incidental, consequential, or indirect damages 
//              arising from the use or operation of the designs or 
//              accompanying documentation, however caused and on any theory 
//              of liability. This limitation will apply even if Xilinx 
//              has been advised of the possibility of such damage. This 
//              limitation shall apply not-withstanding the failure of the 
//              essential purpose of any limited remedies herein. 
//
//  Copyright  2006 Xilinx, Inc.
//  All rights reserved 
// 
//*****************************************************************************
     

// Declare the module.

module PCIX_TOP (
                AD,
                CBE,
                PAR,
                PAR64,
                FRAME_N,
                REQ64_N,
                TRDY_N,
                IRDY_N,
                STOP_N,
                DEVSEL_N,
                ACK64_N,
                IDSEL,
                PERR_N,
                SERR_N,
                INTA_N,
                PMEA_N,
                REQ_N,
                GNT_N,
                RST_N,
                PCLK,
                FPGA_RTR,
                CLK200_N,
                CLK200_P,
                DDR_DIMM_RAS_L, 
                DDR_DIMM_CAS_L, 
                DDR_DIMM_WE_L, 
                DDR_DIMM_CKE0,   
                DDR_DIMM_CKE1, 
                DDR_DIMM_CS_N0_7, // S0_n
                DDR_DIMM_CS_N8_15, // S1_n
                DDR_DIMM_DQ, 
                DDR_DIMM_DQS, 
                DDR_DIMM_CLK0_P, 
                DDR_DIMM_CLK0_N, 
                DDR_DIMM_CLK1_P, 
                DDR_DIMM_CLK1_N, 
                DDR_DIMM_CLK2_P, 
                DDR_DIMM_CLK2_N, 
                DDR_DIMM_BA, 
                DDR_DIMM_ADDRESS, 
                DDR_DIMM_SA, 
                DDR_DIMM_SDA, 
                DDR_DIMM_SCL, 
                DDR_DIMM_DM
             
                );
                // synthesis syn_edif_bit_format = "%u<%i>"
                // synthesis syn_edif_scalar_format = "%u"
                // synthesis syn_noclockbuf = 1 
                // synthesis syn_hier = "hard" 


  // Declare the port directions.

  inout  [63:0] AD;
  inout   [7:0] CBE;
  inout         PAR;
  inout         PAR64;
  inout         FRAME_N;
  inout         REQ64_N;
  inout         TRDY_N;
  inout         IRDY_N;
  inout         STOP_N;
  inout         DEVSEL_N;
  inout         ACK64_N;
  input         IDSEL;
  inout         PERR_N;
  inout         SERR_N;
  output        INTA_N;
  output        PMEA_N;
  output        REQ_N;
  input         GNT_N;
  input         RST_N;
  input         PCLK;   
  output        FPGA_RTR;
  //DDR interface
  input         CLK200_N;
  input         CLK200_P;
  output        DDR_DIMM_RAS_L;
  output        DDR_DIMM_CAS_L;
  output        DDR_DIMM_WE_L;
  output        DDR_DIMM_CKE0;
  output        DDR_DIMM_CKE1;
  output        DDR_DIMM_CS_N0_7;
  output        DDR_DIMM_CS_N8_15;
  output [7:0]  DDR_DIMM_DM;
  inout  [63:0] DDR_DIMM_DQ;
  inout  [7:0]  DDR_DIMM_DQS;
  output        DDR_DIMM_CLK0_P;
  output        DDR_DIMM_CLK0_N;
  output        DDR_DIMM_CLK1_P;
  output        DDR_DIMM_CLK1_N;
  output        DDR_DIMM_CLK2_P;
  output        DDR_DIMM_CLK2_N;
  output[1:0]   DDR_DIMM_BA;
  output[11:0]  DDR_DIMM_ADDRESS;
  output[2:0]   DDR_DIMM_SA;     
  inout         DDR_DIMM_SDA;     
  output        DDR_DIMM_SCL;     



  // Internal wiring to connect instances.

  wire   [63:0] S_DATA_OUT;
  wire    [7:0] S_CBEA_OUT;
  wire   [63:0] S_DATA_IN;
  wire          S_ADDL_VLD;
  wire          S_ADDH_VLD;
  wire          S_ATTR_VLD;
  wire          S_DATL_VLD;
  wire          S_DATH_VLD;
  wire          S_DATA_NXT;
  wire          S_TABORT;
  wire          S_RETRY;
  wire          S_DISCON;
  wire          S_NXTADB;
  wire          S_WAIT;
  wire          S_SPLIT;
  wire          S_WRITE;
  wire          S_DONE;
  wire   [15:0] S_HIT;
  wire   [63:0] M_DATA_OUT;
  wire    [7:0] M_CBEA_IN;
  wire   [63:0] M_DATA_IN;
  wire          M_ADDL_VLD;
  wire          M_ADDH_VLD;
  wire          M_ATTR_VLD;
  wire          M_DATL_VLD;
  wire          M_DATH_VLD;
  wire          M_DATA_NXT;
  wire          M_MABORT;
  wire          M_RETRY;
  wire          M_NXTADB;
  wire          M_DISCON;
  wire          M_TABORT;
  wire          M_SPLIT;
  wire          M_FINISH;
  wire          M_DONE;
  wire          M_REQ;
  wire          UPERR_N;
  wire          USERR_N;
  wire          INT_N;
  wire   [95:0] MS_STAT;
  wire          PME_N;
  wire   [47:0] PM_STAT;
  wire   [31:0] CSR;
  wire          CSR_SYSTEMERR_N; 
  wire          CSRX_UNEXPECTED;
  wire          CSRX_DISCARDED;
  wire   [47:0] CSRX;
  wire          PCIW_EN;
  wire          PCIX_EN;
  wire          RTR;
  wire  [511:0] CFG_BUS;
  wire          RST;
  wire          CLK;
  wire          CLK90;
  wire          CLKDIV;
  wire          dcm_lock;


  // Instantiation of the configuration module.

  CFG XPCI_CFG (.CFG(CFG_BUS));


  // Instantiation of the PCIX interface.

  PCIX_LC XPCI_WRAP (
                .AD_IO(AD),
                .CBE_IO(CBE),
                .PAR_IO(PAR),
                .PAR64_IO(PAR64),
                .FRAME_IO(FRAME_N),
                .REQ64_IO(REQ64_N),
                .TRDY_IO(TRDY_N),
                .IRDY_IO(IRDY_N),
                .STOP_IO(STOP_N),
                .DEVSEL_IO(DEVSEL_N),
                .ACK64_IO(ACK64_N),
                .IDSEL_I(IDSEL),
                .PERR_IO(PERR_N),
                .SERR_IO(SERR_N),
                .INT_O(INTA_N),
                .PME_O(PMEA_N),
                .REQ_O(REQ_N),
                .GNT_I(GNT_N),
                .RST_I(RST_N),
                .CLK_I(PCLK),
                .S_DATA_OUT(S_DATA_OUT),
                .S_CBEA_OUT(S_CBEA_OUT),
                .S_DATA_IN(S_DATA_IN),
                .S_ADDL_VLD(S_ADDL_VLD),
                .S_ADDH_VLD(S_ADDH_VLD),
                .S_ATTR_VLD(S_ATTR_VLD),
                .S_DATL_VLD(S_DATL_VLD),
                .S_DATH_VLD(S_DATH_VLD),
                .S_DATA_NXT(S_DATA_NXT),
                .S_TABORT(S_TABORT),
                .S_RETRY(S_RETRY),
                .S_DISCON(S_DISCON),
                .S_NXTADB(S_NXTADB),
                .S_WAIT(S_WAIT),
                .S_SPLIT(S_SPLIT),
                .S_WRITE(S_WRITE),
                .S_DONE(S_DONE),
                .S_HIT(S_HIT),
                .M_DATA_OUT(M_DATA_OUT),
                .M_CBEA_IN(M_CBEA_IN),
                .M_DATA_IN(M_DATA_IN),
                .M_ADDL_VLD(M_ADDL_VLD),
                .M_ADDH_VLD(M_ADDH_VLD),
                .M_ATTR_VLD(M_ATTR_VLD),
                .M_DATL_VLD(M_DATL_VLD),
                .M_DATH_VLD(M_DATH_VLD),
                .M_DATA_NXT(M_DATA_NXT),
                .M_MABORT(M_MABORT),
                .M_RETRY(M_RETRY),
                .M_NXTADB(M_NXTADB),
                .M_DISCON(M_DISCON),
                .M_TABORT(M_TABORT),
                .M_SPLIT(M_SPLIT),
                .M_FINISH(M_FINISH),
                .M_DONE(M_DONE),
                .M_REQ(M_REQ),
                .PERR_N(UPERR_N),
                .SERR_N(USERR_N),
                .INT_N(INT_N),
                .MS_STAT(MS_STAT),
                .PME_N(PME_N),
                .PM_STAT(PM_STAT),
                .CSR(CSR),
                .CSR_SYSTEMERR_N(CSR_SYSTEMERR_N),
                .CSRX_UNEXPECTED(CSRX_UNEXPECTED),
                .CSRX_DISCARDED(CSRX_DISCARDED), 
                .CSRX(CSRX),
                .PCIW_EN(PCIW_EN),
                .PCIX_EN(PCIX_EN),
                .RTR(RTR),
                .CFG(CFG_BUS),
                .RST(RST),
                .CLK(CLK),
                .CLK90(CLK90),
                .CLKDIV(CLKDIV),
                .DCM_LOCK(dcm_lock)
  );


  // Instantiation of the user application.

  USERAPP XPCI_USER (
                .S_DATA_OUT(S_DATA_OUT),
                .S_CBEA_OUT(S_CBEA_OUT),
                .S_DATA_IN(S_DATA_IN),
                .S_ADDL_VLD(S_ADDL_VLD),
                .S_ADDH_VLD(S_ADDH_VLD),
                .S_ATTR_VLD(S_ATTR_VLD),
                .S_DATL_VLD(S_DATL_VLD),
                .S_DATH_VLD(S_DATH_VLD),
                .S_DATA_NXT(S_DATA_NXT),
                .S_TABORT(S_TABORT),
                .S_RETRY(S_RETRY),
                .S_DISCON(S_DISCON),
                .S_NXTADB(S_NXTADB),
                .S_WAIT(S_WAIT),
                .S_SPLIT(S_SPLIT),
                .S_WRITE(S_WRITE),
                .S_DONE(S_DONE),
                .S_HIT(S_HIT),
                .M_DATA_OUT(M_DATA_OUT),
                .M_CBEA_IN(M_CBEA_IN),
                .M_DATA_IN(M_DATA_IN),
                .M_ADDL_VLD(M_ADDL_VLD),
                .M_ADDH_VLD(M_ADDH_VLD),
                .M_ATTR_VLD(M_ATTR_VLD),
                .M_DATL_VLD(M_DATL_VLD),
                .M_DATH_VLD(M_DATH_VLD),
                .M_DATA_NXT(M_DATA_NXT),
                .M_MABORT(M_MABORT),
                .M_RETRY(M_RETRY),
                .M_NXTADB(M_NXTADB),
                .M_DISCON(M_DISCON),
                .M_TABORT(M_TABORT),
                .M_SPLIT(M_SPLIT),
                .M_FINISH(M_FINISH),
                .M_DONE(M_DONE),
                .M_REQ(M_REQ),
                .PERR_N(UPERR_N),
                .SERR_N(USERR_N),
                .INT_N(INT_N),
                .MS_STAT(MS_STAT),
                .PME_N(PME_N),
                .PM_STAT(PM_STAT),
                .CSR(CSR),
                .CSR_SYSTEMERR_N(CSR_SYSTEMERR_N),
                .CSRX_UNEXPECTED(CSRX_UNEXPECTED),
                .CSRX_DISCARDED(CSRX_DISCARDED), 
                .CSRX(CSRX),
                .PCIW_EN(PCIW_EN),
                .PCIX_EN(PCIX_EN),
                .RTR(RTR),
                .CFG(CFG_BUS),
                .RST(RST),
                .CLK(CLK), //also used as DDR_CLK0 and USER_CLK
                .FPGA_RTR(FPGA_RTR),
                //DDR interface
                .DDR_CLK90(CLK90),
                .DDR_CLKDIV(CLKDIV),
                .CLK200_N(CLK200_N), 
                .CLK200_P(CLK200_P), 
                .USER_CLK(CLK),
                .SYS_RESET_IN(RST),//(SYS_RESET_IN), 
                .DDR_DIMM_RAS_L(DDR_DIMM_RAS_L), 
                .DDR_DIMM_CAS_L(DDR_DIMM_CAS_L), 
                .DDR_DIMM_WE_L(DDR_DIMM_WE_L), 
                .DDR_DIMM_CKE0(DDR_DIMM_CKE0), 
                .DDR_DIMM_CKE1(DDR_DIMM_CKE1),
                .DDR_DIMM_CS_N0_7(DDR_DIMM_CS_N0_7), 
                .DDR_DIMM_CS_N8_15(DDR_DIMM_CS_N8_15), 
                .DDR_DIMM_DQ(DDR_DIMM_DQ), 
                .DDR_DIMM_DQS(DDR_DIMM_DQS), 
                .DDR_DIMM_CLK0_P(DDR_DIMM_CLK0_P), 
                .DDR_DIMM_CLK0_N(DDR_DIMM_CLK0_N), 
                .DDR_DIMM_CLK1_P(DDR_DIMM_CLK1_P), 
                .DDR_DIMM_CLK1_N(DDR_DIMM_CLK1_N), 
                .DDR_DIMM_CLK2_P(DDR_DIMM_CLK2_P), 
                .DDR_DIMM_CLK2_N(DDR_DIMM_CLK2_N), 
                .DDR_DIMM_BA(DDR_DIMM_BA), 
                .DDR_DIMM_ADDRESS(DDR_DIMM_ADDRESS), 
                .DDR_DIMM_SA(DDR_DIMM_SA), 
                .DDR_DIMM_SDA(DDR_DIMM_SDA), 
                .DDR_DIMM_SCL(DDR_DIMM_SCL), 
                .DDR_DIMM_DM(DDR_DIMM_DM),
                .DCM_LOCK(dcm_lock)
               );

endmodule
