/***********************************************************************
 
  File:   test_tb.v
  Rev:    5.0.0

  This is a slapup test harness for sanity checks.

  Copyright (c) 2003 Xilinx, Inc.  All rights reserved.

***********************************************************************/
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
//              provided to you "as is". Xilinx and its licensors make and you 
//              receive no warranties or conditions, express, implied, 
//              statutory or otherwise, and Xilinx specifically disclaims any 
//              implied warranties of merchantability, non-infringement, or 
//              fitness for a particular purpose. Xilinx does not warrant that 
//              the functions contained in these designs will meet your 
//              requirements, or that the operation of these designs will be 
//              uninterrupted or error free, or that defects in the Designs 
//              will be corrected. Furthermore, Xilinx does not warrant or 
//              make any representations regarding use or the results of the 
//              use of the designs in terms of correctness, accuracy, 
//              reliability, or otherwise. 
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its 
//              licensors be liable for any loss of data, lost profits, cost 
//              or procurement of substitute goods or services, or for any 
//              special, incidental, consequential, or indirect damages 
//              arising from the use or operation of the designs or 
//              accompanying documentation, however caused and on any theory 
//              of liability. This limitation will apply even if Xilinx 
//              has been advised of the possibility of such damage. This 
//              limitation shall apply not-withstanding the failure of the 
//              essential purpose of any limited remedies herein. 
//
//  Copyright  2006 Xilinx, Inc.
//  All rights reserved 
// 
//*****************************************************************************

`timescale 1 ns / 1 ps


//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
//              provided to you "as is". Xilinx and its licensors make and you 
//              receive no warranties or conditions, express, implied, 
//              statutory or otherwise, and Xilinx specifically disclaims any 
//              implied warranties of merchantability, non-infringement, or 
//              fitness for a particular purpose. Xilinx does not warrant that 
//              the functions contained in these designs will meet your 
//              requirements, or that the operation of these designs will be 
//              uninterrupted or error free, or that defects in the Designs 
//              will be corrected. Furthermore, Xilinx does not warrant or 
//              make any representations regarding use or the results of the 
//              use of the designs in terms of correctness, accuracy, 
//              reliability, or otherwise. 
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its 
//              licensors be liable for any loss of data, lost profits, cost 
//              or procurement of substitute goods or services, or for any 
//              special, incidental, consequential, or indirect damages 
//              arising from the use or operation of the designs or 
//              accompanying documentation, however caused and on any theory 
//              of liability. This limitation will apply even if Xilinx 
//              has been advised of the possibility of such damage. This 
//              limitation shall apply not-withstanding the failure of the 
//              essential purpose of any limited remedies herein. 
//
//  Copyright  2005 Xilinx, Inc.
//  All rights reserved 
// 
//*****************************************************************************


module TEST_TB;

   parameter dimm_delay = 2.3; //2.5;
  // PCI Bus Signals.

  wire   [63:0] AD;
  wire    [7:0] CBE;
  wire          PAR;
  wire          PAR64;
  tri1          FRAME_N;
  tri1          REQ64_N; 
  tri1          TRDY_N;
  tri1          IRDY_N;
  tri1          STOP_N;
  tri1          DEVSEL_N;
  tri1          ACK64_N;
  wire          IDSEL;
  tri1          INTA_N;
  tri1          PMEA_N;
  tri1          PERR_N;
  tri1          SERR_N;
  tri1          REQ_N;
  tri1          GNT_N;
  wire          RST_N;
  wire          CLK;
  wire          FPGA_RTR;
 // Outputs
  wire #dimm_delay DDR_CS0_L;
  wire #dimm_delay DDR_CS1_L;
  wire #dimm_delay DDR_CS2_L;
  wire #dimm_delay DDR_CS3_L;
  wire #dimm_delay DDR_CKE;
  wire #dimm_delay DDR_DIMM_RAS_L;
  wire #dimm_delay DDR_DIMM_CAS_L;
  wire #dimm_delay DDR_DIMM_WE_L;
  wire #dimm_delay DDR_DIMM_CKE0, DDR_DIMM_CKE1;
  wire #dimm_delay DDR_DIMM_CS_N0_7;
  wire #dimm_delay DDR_DIMM_CS_N8_15;
  wire #dimm_delay DDR_DIMM_CLK0_P;
  wire #dimm_delay DDR_DIMM_CLK0_N;
  wire #dimm_delay DDR_DIMM_CLK1_P;
  wire #dimm_delay DDR_DIMM_CLK1_N;   
  wire #dimm_delay DDR_DIMM_CLK2_P;
  wire #dimm_delay DDR_DIMM_CLK2_N;
  wire [1:0] #dimm_delay DDR_DIMM_BA;
  wire [11:0]#dimm_delay DDR_DIMM_ADDRESS;
  wire [2:0] #dimm_delay DDR_DIMM_SA;
  wire #dimm_delay DDR_DIMM_SCL;
  //Bidirs
  wire [63:0] #dimm_delay DDR_DIMM_DQ;
  wire [7:0] #dimm_delay DDR_DIMM_DQS;
  wire [7:0] #dimm_delay DDR_DIMM_DM;
  wire #dimm_delay DDR_DIMM_SDA;
  wire [1:0] #dimm_delay DDR_DIMM_READ_EN_IN;

  // Inputs
  reg  DDR_CLK_N;
  reg  DDR_CLK_P;
  reg  CLK200_N;
  reg  CLK200_P;
 // reg USER_CLK;
  reg SYS_RESET_IN;

  // Instantiate master stimulus device.

  STIMULUS STM  (
                .AD( AD ),
                .CBE( CBE ),
                .PAR( PAR ),
                .PAR64( PAR64 ),
                .FRAME_N( FRAME_N ),
                .REQ64_N( REQ64_N ),
                .TRDY_N( TRDY_N ),
                .IRDY_N( IRDY_N ),
                .STOP_N( STOP_N ),
                .DEVSEL_N( DEVSEL_N ),
                .ACK64_N( ACK64_N ),
                .IDSEL( IDSEL ),
                .INTA_N( INTA_N ),
                .PMEA_N( PMEA_N ),
                .PERR_N( PERR_N ),
                .SERR_N( SERR_N ),
                .REQ_N( REQ_N ),
                .GNT_N( GNT_N ),
                .RST_N( RST_N ),
                .CLK( CLK ),
                .FPGA_RTR( FPGA_RTR )
                );


  // Instantiate FPGA PCI design.

  PCIX_TOP UUT  (
                .AD( AD ),
                .CBE( CBE ),
                .PAR( PAR ),
                .PAR64( PAR64 ),
                .FRAME_N( FRAME_N ),
                .REQ64_N( REQ64_N ),
                .TRDY_N( TRDY_N ),
                .IRDY_N( IRDY_N ),
                .STOP_N( STOP_N ),
                .DEVSEL_N( DEVSEL_N ),
                .ACK64_N( ACK64_N ),
                .IDSEL( IDSEL ),
                .INTA_N( INTA_N ),
                .PMEA_N( PMEA_N ),
                .PERR_N( PERR_N ),
                .SERR_N( SERR_N ),
                .REQ_N( REQ_N ),
                .GNT_N( GNT_N ),
                .RST_N( RST_N ),
                .PCLK( CLK ),
                .FPGA_RTR( FPGA_RTR ),
                //DDR interface
                .CLK200_N(CLK200_N), 
                .CLK200_P(CLK200_P), 
                .DDR_DIMM_RAS_L(DDR_DIMM_RAS_L), 
                .DDR_DIMM_CAS_L(DDR_DIMM_CAS_L), 
                .DDR_DIMM_WE_L(DDR_DIMM_WE_L), 
                .DDR_DIMM_CKE0(DDR_DIMM_CKE0), 
                .DDR_DIMM_CKE1(DDR_DIMM_CKE1),
                .DDR_DIMM_CS_N0_7(DDR_DIMM_CS_N0_7), 
                .DDR_DIMM_CS_N8_15(DDR_DIMM_CS_N8_15), 
                .DDR_DIMM_DQ(DDR_DIMM_DQ), 
                .DDR_DIMM_DQS(DDR_DIMM_DQS), 
                .DDR_DIMM_CLK0_P(DDR_DIMM_CLK0_P), 
                .DDR_DIMM_CLK0_N(DDR_DIMM_CLK0_N), 
                .DDR_DIMM_CLK1_P(DDR_DIMM_CLK1_P), 
                .DDR_DIMM_CLK1_N(DDR_DIMM_CLK1_N), 
                .DDR_DIMM_CLK2_P(DDR_DIMM_CLK2_P), 
                .DDR_DIMM_CLK2_N(DDR_DIMM_CLK2_N), 
                .DDR_DIMM_BA(DDR_DIMM_BA), 
                .DDR_DIMM_ADDRESS(DDR_DIMM_ADDRESS), 
                .DDR_DIMM_SA(DDR_DIMM_SA), 
                .DDR_DIMM_SDA(DDR_DIMM_SDA), 
                .DDR_DIMM_SCL(DDR_DIMM_SCL), 
                .DDR_DIMM_DM(DDR_DIMM_DM)
                );


  ddr_dimm u_dimm(
              .Dq(DDR_DIMM_DQ[63:0]), 
              .Dqs(DDR_DIMM_DQS),
              .Addr({DDR_DIMM_ADDRESS[11:0]}), 
              .Ba(DDR_DIMM_BA), 
              .Clk0(DDR_DIMM_CLK0_N), 
              .Clk0_n(DDR_DIMM_CLK0_P), 
              .Clk1(DDR_DIMM_CLK1_N), 
              .Clk1_n(DDR_DIMM_CLK1_P), 
              .Clk2(DDR_DIMM_CLK2_N), 
              .Clk2_n(DDR_DIMM_CLK2_P),
              .Cke0(DDR_DIMM_CKE0), 
              .Cke1(DDR_DIMM_CKE1), 
              .Ras_n(DDR_DIMM_RAS_L), 
              .Cas_n(DDR_DIMM_CAS_L), 
              .We_n(DDR_DIMM_WE_L), 
              .Dm(DDR_DIMM_DM), 
              .S0_n(DDR_DIMM_CS_N0_7), 
              .S1_n(DDR_DIMM_CS_N8_15)
              );
	      
reg [20*10:0] command_ascii;
always @(DDR_DIMM_RAS_L or DDR_DIMM_CAS_L or DDR_DIMM_WE_L)
case ({DDR_DIMM_RAS_L,DDR_DIMM_CAS_L,DDR_DIMM_WE_L})
 3'b111              :    command_ascii = "NOP"; 
 3'b011              :     command_ascii = "ACTIVE";
 3'b101              :    command_ascii = "READ";
 3'b100               :     command_ascii = "WRITE";
 3'b110               :     command_ascii = "BURST TERMINATE";
 3'b010               :     command_ascii = "PRECHARGE";
 3'b001               :     command_ascii = "AUTO REFRESH";
 3'b000               :     command_ascii = "LMR";
 default             :    command_ascii = "ILLEGAL"; 
endcase 


  // Start the simulation history manager.

  initial
  begin
    $shm_open("waves.shm");
    $shm_probe("AC");
  end


  // Extension pull ups

  pullup (PAR64);

  pullup (CBE[7]);
  pullup (CBE[6]);
  pullup (CBE[5]);
  pullup (CBE[4]);

  pullup (AD[63]);
  pullup (AD[62]);
  pullup (AD[61]);
  pullup (AD[60]);
  pullup (AD[59]);
  pullup (AD[58]);
  pullup (AD[57]);
  pullup (AD[56]);
  pullup (AD[55]);
  pullup (AD[54]);
  pullup (AD[53]);
  pullup (AD[52]);
  pullup (AD[51]);
  pullup (AD[50]);
  pullup (AD[49]);
  pullup (AD[48]);
  pullup (AD[47]);
  pullup (AD[46]);
  pullup (AD[45]);
  pullup (AD[44]);
  pullup (AD[43]);
  pullup (AD[42]);
  pullup (AD[41]);
  pullup (AD[40]);
  pullup (AD[39]);
  pullup (AD[38]);
  pullup (AD[37]);
  pullup (AD[36]);
  pullup (AD[35]);
  pullup (AD[34]);
  pullup (AD[33]);
  pullup (AD[32]);

//DDR clock and reset stimulus

      always #(3.75) DDR_CLK_N = ~DDR_CLK_N; //
      always #(3.75) DDR_CLK_P = ~DDR_CLK_P; //
      always #(2.5) CLK200_N = ~CLK200_N;     //
      always #(2.5) CLK200_P = ~CLK200_P;     //

        initial begin
            DDR_CLK_N = 0;
            DDR_CLK_P = 1;
            CLK200_N = 0;
            CLK200_P = 1;
            SYS_RESET_IN = 1;
            #100;
            SYS_RESET_IN = 0;
            #100000;
            SYS_RESET_IN = 1;
        end

endmodule
