//***********************************************************************
//
//  File:   userapp.v
//  Rev:    5.0.0
//
//  This is an example template for the user backend application.
//
//  Copyright (c) 2003 Xilinx, Inc.  All rights reserved.
//
//
//  Contact : e-mail  hotline@xilinx.com
//            phone   + 1 800 255 7778 
//
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
//              provided to you "as is". Xilinx and its licensors make and you 
//              receive no warranties or conditions, express, implied, 
//              statutory or otherwise, and Xilinx specifically disclaims any 
//              implied warranties of merchantability, non-infringement, or 
//              fitness for a particular purpose. Xilinx does not warrant that 
//              the functions contained in these designs will meet your 
//              requirements, or that the operation of these designs will be 
//              uninterrupted or error free, or that defects in the Designs 
//              will be corrected. Furthermore, Xilinx does not warrant or 
//              make any representations regarding use or the results of the 
//              use of the designs in terms of correctness, accuracy, 
//              reliability, or otherwise. 
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its 
//              licensors be liable for any loss of data, lost profits, cost 
//              or procurement of substitute goods or services, or for any 
//              special, incidental, consequential, or indirect damages 
//              arising from the use or operation of the designs or 
//              accompanying documentation, however caused and on any theory 
//              of liability. This limitation will apply even if Xilinx 
//              has been advised of the possibility of such damage. This 
//              limitation shall apply not-withstanding the failure of the 
//              essential purpose of any limited remedies herein. 
//
//  Copyright  2006 Xilinx, Inc.
//  All rights reserved 
// 
//*****************************************************************************


   `define BAR2_IDLE  2'b01
   `define BAR2_LATCH  2'b10

module USERAPP  (
                S_DATA_OUT,
                S_CBEA_OUT,
                S_DATA_IN,
                S_ADDL_VLD,
                S_ADDH_VLD,
                S_ATTR_VLD,
                S_DATL_VLD,
                S_DATH_VLD,
                S_DATA_NXT,
                S_TABORT,
                S_RETRY,
                S_DISCON,
                S_NXTADB,
                S_WAIT,
                S_SPLIT,
                S_WRITE,
                S_DONE,
                S_HIT,
                M_DATA_OUT,
                M_CBEA_IN,
                M_DATA_IN,
                M_ADDL_VLD,
                M_ADDH_VLD,
                M_ATTR_VLD,
                M_DATL_VLD,
                M_DATH_VLD,
                M_DATA_NXT,
                M_MABORT,
                M_RETRY,
                M_NXTADB,
                M_DISCON,
                M_TABORT,
                M_SPLIT,
                M_FINISH,
                M_DONE,
                M_REQ,
                PERR_N,
                SERR_N,
                INT_N,
                MS_STAT,
                PME_N,
                PM_STAT,
                CSR,
                CSR_SYSTEMERR_N, 
                CSRX_UNEXPECTED, 
                CSRX_DISCARDED, 
                CSRX,
                PCIW_EN,
                PCIX_EN,
                RTR,
                CFG,
                RST,
                CLK,
                FPGA_RTR,
                DDR_CLK90,
                DDR_CLKDIV,
                CLK200_N,
                CLK200_P,
                USER_CLK,
                SYS_RESET_IN,
                DDR_DIMM_RAS_L, 
                DDR_DIMM_CAS_L, 
                DDR_DIMM_WE_L, 
                DDR_DIMM_CKE0,   
                DDR_DIMM_CKE1, 
                DDR_DIMM_CS_N0_7, // S0_n
                DDR_DIMM_CS_N8_15, // S1_n
                DDR_DIMM_DQ, 
                DDR_DIMM_DQS, 
                DDR_DIMM_CLK0_P, 
                DDR_DIMM_CLK0_N, 
                DDR_DIMM_CLK1_P, 
                DDR_DIMM_CLK1_N, 
                DDR_DIMM_CLK2_P, 
                DDR_DIMM_CLK2_N, 
                DDR_DIMM_BA, 
                DDR_DIMM_ADDRESS, 
                DDR_DIMM_SA, 
                DDR_DIMM_SDA, 
                DDR_DIMM_SCL, 
                DDR_DIMM_DM,
                DCM_LOCK
                );
                // synthesis syn_edif_bit_format = "%u<%i>"
                // synthesis syn_edif_scalar_format = "%u"
                // synthesis syn_noclockbuf = 1 
                // synthesis syn_hier = "hard" 


  // Declare the port directions.

  input  [63:0] S_DATA_OUT;  // target address, attribute and write data bus
  input   [7:0] S_CBEA_OUT;  // command byte enables
  output [63:0] S_DATA_IN;   // target read data bus
  input         S_ADDL_VLD;  // lower 32-bit address valid
  input         S_ADDH_VLD;  // upper 32-bit address valid
  input         S_ATTR_VLD;  // target attributes valid
  input         S_DATL_VLD;  // lower 32-bit data valid
  input         S_DATH_VLD;  // upper 32-bit data valid
  input         S_DATA_NXT;  // next data requested
  output        S_TABORT;    // slave target abort
  output        S_RETRY;     // slave retry
  output        S_DISCON;    // slave disconnect request
  output        S_NXTADB;    
  output        S_WAIT;      // target wait: PCI-X only prior to 1st data transfer
  output        S_SPLIT;     // split transaction requested
  input         S_WRITE;     // target write request
  input         S_DONE;      // target done
  input  [15:0] S_HIT;       // 
  input  [63:0] M_DATA_OUT;
  output  [7:0] M_CBEA_IN;
  output [63:0] M_DATA_IN;
  input         M_ADDL_VLD;
  input         M_ADDH_VLD;
  input         M_ATTR_VLD;
  input         M_DATL_VLD;
  input         M_DATH_VLD;
  input         M_DATA_NXT;
  input         M_MABORT;
  input         M_RETRY;
  input         M_NXTADB;
  input         M_DISCON;
  input         M_TABORT;
  input         M_SPLIT;
  output        M_FINISH;
  input         M_DONE;
  output        M_REQ;
  input         PERR_N;
  input         SERR_N;
  output        INT_N;
  input  [95:0] MS_STAT;
  output        PME_N;
  input  [47:0] PM_STAT;
  input  [31:0] CSR;
  output        CSR_SYSTEMERR_N; 
  output        CSRX_UNEXPECTED;
  output        CSRX_DISCARDED;
  input  [47:0] CSRX;
  input         PCIW_EN;
  input         PCIX_EN;
  input         RTR;
  input [511:0] CFG;
  input         RST;
  input         CLK;
  output        FPGA_RTR;
  //DDR interface
  input         DDR_CLK90;
  input         DDR_CLKDIV;
  input         CLK200_N;
  input         CLK200_P;
  input         USER_CLK;
  input         SYS_RESET_IN;
  output        DDR_DIMM_RAS_L;
  output        DDR_DIMM_CAS_L;
  output        DDR_DIMM_WE_L;
  output        DDR_DIMM_CKE0;
  output        DDR_DIMM_CKE1;
  output        DDR_DIMM_CS_N0_7;
  output        DDR_DIMM_CS_N8_15;
  output [7:0]  DDR_DIMM_DM;
  inout [63:0]  DDR_DIMM_DQ;
  inout [7:0]   DDR_DIMM_DQS;
  output        DDR_DIMM_CLK0_P;
  output        DDR_DIMM_CLK0_N;
  output        DDR_DIMM_CLK1_P;
  output        DDR_DIMM_CLK1_N;
  output        DDR_DIMM_CLK2_P;
  output        DDR_DIMM_CLK2_N;
  output[1:0]   DDR_DIMM_BA;
  output[11:0]  DDR_DIMM_ADDRESS;
  output[2:0]   DDR_DIMM_SA;     
  inout         DDR_DIMM_SDA;     
  output        DDR_DIMM_SCL;     
  input         DCM_LOCK;

  reg           bar0, bar1, bar2;
  wire          bar0_rd_cs, bar1_rd_cs, bar2_rd_cs;
  wire          bar0_wr_cs, bar1_wr_cs, bar2_wr_cs;
  reg           pci_hit_early;
  wire          s_wait_w;
  wire          DDR_NOT_READY;


wire [63:0] RAMDOUT;
wire  [7:0] BRAMWE;

  //******************************************************************//
  // This section contains unused signals.                            //
  //******************************************************************//

 
  reg           reg_s_tabort;
  reg           reg_s_retry;
  reg           reg_s_discon;
  reg           reg_s_nxtadb;
  reg           reg_s_wait;
  reg           reg_s_split;
  reg           reg_int_n;
  reg           reg_pme_n;

 
  always @(posedge CLK or posedge RST)
  begin : unused_signals_s
    if (RST)
    begin
      reg_s_tabort <= 1'b1;
      reg_s_retry <= 1'b1;
      reg_s_discon <= 1'b1;
      reg_s_nxtadb <= 1'b1;
      reg_s_wait <= 1'b1;
      reg_s_split <= 1'b1;
      reg_int_n <= 1'b1;  
      reg_pme_n <= 1'b1;
    end
    else
    begin
      reg_s_tabort <= 1'b0;
      reg_s_retry <= 1'b0;
      reg_s_discon <= 1'b0;
      reg_s_nxtadb <= 1'b0;
      reg_s_wait <= 1'b0; 
      reg_s_split <= 1'b0;
      reg_int_n <= 1'b1;
      reg_pme_n <= 1'b1;
    end
  end

  assign S_TABORT = reg_s_tabort;
  assign S_RETRY = DDR_NOT_READY;
  assign S_DISCON = reg_s_discon;
  assign S_NXTADB = reg_s_nxtadb;
  assign S_WAIT = s_wait_w & !S_RETRY;
  assign S_SPLIT = reg_s_split;

  assign INT_N = reg_int_n;
  assign PME_N = reg_pme_n;  
  assign S_DATA_IN = {RAMDOUT[31:0],RAMDOUT[63:32]};

  //******************************************************************//
  // This section contains unused signals.                            //
  //******************************************************************//

  reg           reg_m_finish;

  always @(posedge CLK or posedge RST)
  begin : unused_signals_m 
    if (RST)
    begin
      reg_m_finish <= 1'b1;
    end
    else
    begin
      reg_m_finish <= 1'b0;
    end
  end


  assign M_CBEA_IN = 8'h00;
  assign M_DATA_IN = 64'h0000000000000000;
  assign M_FINISH = reg_m_finish;
  assign M_REQ = 1'b0;    

  assign CSR_SYSTEMERR_N = 1'b1;
  assign CSRX_UNEXPECTED = 1'b0;
  assign CSRX_DISCARDED = 1'b0;


  //******************************************************************//
  //  This section contains DDR-1 DIMM controller - Optimized for PCI //
  //  and PCI-X                                                       //
  //  Dual Rank, 4 word burst, 133 MHz, 128 MB(16MEG x 64)            //
  //******************************************************************//

  //*******************************************************************
  // In order to meet PCI-X 16 cycle latency spec we need to predecode
  // the address bus for read operations.  This will allow the DDR 
  // controller to activate row/bank at the earliest possible time
  //*******************************************************************

   //latch S_DATA_OUT[15:0] when S_ADDL_VLD is high
   reg [15:0] s_data_keep;
   always@(posedge CLK)begin
      if(RST)begin
         s_data_keep[7:0] <= 0;
      end else if(S_ADDL_VLD)begin
         s_data_keep[7:0] <= S_DATA_OUT[7:0];
      end else begin
         s_data_keep <= s_data_keep;
      end
    end

   //state machine to mimic BAR2
   //only need the upper 5 bits for addr decode
     reg [1:0] bar2_state;
     reg [4:0] upper_addr;

   always@(posedge CLK or posedge RST) begin
      if (RST) begin
         bar2_state <= `BAR2_IDLE;
         upper_addr <= 5'b00000;
      end
      else begin
         case (bar2_state) 
            `BAR2_IDLE : begin //S_HIT[6] is same as IDSEL delayed by 2
               if (S_WRITE && S_HIT[6] && (s_data_keep[7:0] == 8'h18))begin
                  bar2_state <= `BAR2_LATCH;
               end else begin 
                  bar2_state <= `BAR2_IDLE; 
               end             
               upper_addr[4:0] <= upper_addr[4:0];
            end
            `BAR2_LATCH : begin
               if (S_DATL_VLD == 1'b1)begin
                  bar2_state <= `BAR2_IDLE;
                  upper_addr[4:0] <= S_DATA_OUT[31:27];
               end else begin
                  bar2_state <= `BAR2_LATCH;
                  upper_addr[4:0] <= upper_addr[4:0];
               end                        
            end 
            default:   begin
                  bar2_state <= `BAR2_IDLE;
                  upper_addr[4:0] <= upper_addr[4:0];
               end          
         endcase
       end
     end
  // do the decode combinatorially for quickest timing
     always@(S_DATA_OUT[31:27], S_ADDL_VLD, upper_addr[4:0])begin
        if(S_DATA_OUT[31:27] == upper_addr[4:0] && S_ADDL_VLD == 1'b1) 
             pci_hit_early <= 1'b1;        
        else pci_hit_early <= 1'b0;
     end


  // Instantiate the ddr controller
    ddr_top ddr_top_inst (
        .DDR_CLK90(DDR_CLK90), 
        .DDR_CLKDIV(DDR_CLKDIV),  
        .CLK200_N(CLK200_N), 
        .CLK200_P(CLK200_P), 
        .USER_CLK(USER_CLK),//same as CLK(PCIX CLK) will also be used as DDR_CLK0 for this design
        .SYS_RESET_IN(SYS_RESET_IN), 
        .DDR_DIMM_RAS_L(DDR_DIMM_RAS_L), 
        .DDR_DIMM_CAS_L(DDR_DIMM_CAS_L), 
        .DDR_DIMM_WE_L(DDR_DIMM_WE_L), 
        .DDR_DIMM_CKE0(DDR_DIMM_CKE0), 
        .DDR_DIMM_CKE1(DDR_DIMM_CKE1),
        .DDR_DIMM_CS_N0_7(DDR_DIMM_CS_N0_7), 
        .DDR_DIMM_CS_N8_15(DDR_DIMM_CS_N8_15), 
        .DDR_DIMM_DQ(DDR_DIMM_DQ), 
        .DDR_DIMM_DQS(DDR_DIMM_DQS), 
        .DDR_DIMM_CLK0_P(DDR_DIMM_CLK0_P), 
        .DDR_DIMM_CLK0_N(DDR_DIMM_CLK0_N), 
        .DDR_DIMM_CLK1_P(DDR_DIMM_CLK1_P), 
        .DDR_DIMM_CLK1_N(DDR_DIMM_CLK1_N), 
        .DDR_DIMM_CLK2_P(DDR_DIMM_CLK2_P), 
        .DDR_DIMM_CLK2_N(DDR_DIMM_CLK2_N), 
        .DDR_DIMM_BA(DDR_DIMM_BA), 
        .DDR_DIMM_ADDRESS(DDR_DIMM_ADDRESS), 
        .DDR_DIMM_SA(DDR_DIMM_SA), 
        .DDR_DIMM_SDA(DDR_DIMM_SDA), 
        .DDR_DIMM_SCL(DDR_DIMM_SCL), 
        .DDR_DIMM_DM(DDR_DIMM_DM),
        .PCI_ADDR(S_DATA_OUT[26:0]),
        .PCI_DATA_IN(S_DATA_OUT[63:0]),
        .PCI_CBEA(S_CBEA_OUT[7:0]),
        .PCI_WRITE(S_WRITE),
        .PCI_WRITE_VALID(S_DATH_VLD),
        .PCI_HIT(S_HIT[2]),
        .PCI_HIT_EARLY(pci_hit_early),
        .READ_DATA_OUT(RAMDOUT),
        .READ_DATA_VALID(),
        .DDR_NOT_READY(DDR_NOT_READY),
        .DCM_LOCK(DCM_LOCK),
        .S_WAIT(s_wait_w),
        .S_DONE(S_DONE)
        );
                     
endmodule 
