
--  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
--              provided to you "as is". Xilinx and its licensors make and you 
--              receive no warranties or conditions, express, implied, 
--              statutory or otherwise, and Xilinx specifically disclaims any 
--              implied warranties of merchantability, non-infringement, or 
--              fitness for a particular purpose. Xilinx does not warrant that 
--              the functions contained in these designs will meet your 
--              requirements, or that the operation of these designs will be 
--              uninterrupted or error free, or that defects in the Designs 
--              will be corrected. Furthermore, Xilinx does not warrant or 
--              make any representations regarding use or the results of the 
--              use of the designs in terms of correctness, accuracy, 
--              reliability, or otherwise. 
--
--              LIMITATION OF LIABILITY. In no event will Xilinx or its 
--              licensors be liable for any loss of data, lost profits, cost 
--              or procurement of substitute goods or services, or for any 
--              special, incidental, consequential, or indirect damages 
--              arising from the use or operation of the designs or 
--              accompanying documentation, however caused and on any theory 
--              of liability. This limitation will apply even if Xilinx 
--              has been advised of the possibility of such damage. This 
--              limitation shall apply not-withstanding the failure of the 
--              essential purpose of any limited remedies herein. 
--
--  Copyright  2005 Xilinx, Inc.
--  All rights reserved 
-- 
-------------------------------------------------------------------------------


-- TestBench Template 

  LIBRARY ieee;
  USE ieee.std_logic_1164.ALL;
  USE ieee.numeric_std.ALL;
  LIBRARY UNISIM;
  USE UNISIM.VCOMPONENTS.ALL;

  ENTITY test_tb IS
  END test_tb;

  ARCHITECTURE behavior OF test_tb IS 

  -- Component Declaration
COMPONENT STIMULUS 
   PORT (
      AD                      : INOUT std_logic_vector(63 DOWNTO 0);   
      CBE                     : INOUT std_logic_vector(7 DOWNTO 0);   
      PAR                     : INOUT std_logic;   
      PAR64                   : INOUT std_logic;  
      FRAME_N                 : INOUT std_logic;   
      REQ64_N                 : INOUT std_logic;   
      TRDY_N                  : INOUT std_logic;   
      IRDY_N                  : INOUT std_logic;   
      STOP_N                  : INOUT std_logic;   
      DEVSEL_N                : INOUT std_logic;   
      ACK64_N                 : INOUT std_logic;   
      IDSEL                   : OUT std_logic;   
      INTA_N                  : IN std_logic;   
      PMEA_N                  : IN std_logic;   
      PERR_N                  : IN std_logic;     
      SERR_N                  : IN std_logic;   
      REQ_N                   : IN std_logic;   
      GNT_N                   : INOUT std_logic;   
      RST_N                   : OUT std_logic;   
      CLK                     : OUT std_logic;   
      FPGA_RTR                : IN std_logic);   
END COMPONENT;

COMPONENT PCIX_TOP
   PORT (
      AD                      : INOUT std_logic_vector(63 DOWNTO 0);   
      CBE                     : INOUT std_logic_vector(7 DOWNTO 0);   
      PAR                     : INOUT std_logic;   
      PAR64                   : INOUT std_logic;   
      FRAME_N                 : INOUT std_logic;   
      REQ64_N                 : INOUT std_logic;   
      TRDY_N                  : INOUT std_logic;   
      IRDY_N                  : INOUT std_logic;   
      STOP_N                  : INOUT std_logic;   
      DEVSEL_N                : INOUT std_logic;   
      ACK64_N                 : INOUT std_logic;   
      IDSEL                   : IN std_logic;   
      PERR_N                  : INOUT std_logic;   
      SERR_N                  : INOUT std_logic;   
      INTA_N                  : OUT std_logic;   
      PMEA_N                  : OUT std_logic;   
      REQ_N                   : OUT std_logic;   
      GNT_N                   : IN std_logic;   
      RST_N                   : IN std_logic;   
      PCLK                    : IN std_logic;   
      FPGA_RTR                : OUT std_logic;   
      CLK200_N                : IN std_logic;   
      CLK200_P                : IN std_logic;   
      DDR_DIMM_RAS_L          : OUT std_logic;   
      DDR_DIMM_CAS_L          : OUT std_logic;   
      DDR_DIMM_WE_L           : OUT std_logic;   
      DDR_DIMM_CKE0           : OUT std_logic;   
      DDR_DIMM_CKE1           : OUT std_logic;   
      DDR_DIMM_CS_N0_7        : OUT std_logic;   
      DDR_DIMM_CS_N8_15       : OUT std_logic;   
      DDR_DIMM_DQ             : INOUT std_logic_vector(63 DOWNTO 0);   
      DDR_DIMM_DQS            : INOUT std_logic_vector(7 DOWNTO 0);   
      DDR_DIMM_CLK0_P         : OUT std_logic;   
      DDR_DIMM_CLK0_N         : OUT std_logic;   
      DDR_DIMM_CLK1_P         : OUT std_logic;   
      DDR_DIMM_CLK1_N         : OUT std_logic;   
      DDR_DIMM_CLK2_P         : OUT std_logic;   
      DDR_DIMM_CLK2_N         : OUT std_logic;   
      DDR_DIMM_BA             : OUT std_logic_vector(1 DOWNTO 0);   
      DDR_DIMM_ADDRESS        : OUT std_logic_vector(11 DOWNTO 0);   
      DDR_DIMM_SA             : OUT std_logic_vector(2 DOWNTO 0);   
      DDR_DIMM_SDA            : INOUT std_logic;   
      DDR_DIMM_SCL            : OUT std_logic;   
      DDR_DIMM_DM             : OUT std_logic_vector(7 DOWNTO 0));   
END COMPONENT;

COMPONENT ddr_dimm 
--   GENERIC (
--      ADDR_BITS                      :  integer := 12;    --  Set this parameter to control how many Address bits are used

--      DQ_BITS                        :  integer := 16;    --  Set this parameter to control how many Data bits are used

--      DQS_BITS                       :  integer := 2;    --  Set this parameter to control how many DQS bits are used

--      DM_BITS                        :  integer := 2;    --  Set this parameter to control how many DM bits are used

--      COL_BITS                       :  integer := 9);    --  Set this parameter to control how many Column bits are used

         PORT (
      Dq                      : INOUT std_logic_vector(63 DOWNTO 0);   
      Dqs                     : INOUT std_logic_vector(7 DOWNTO 0);   
      Addr                    : IN std_logic_vector(11 DOWNTO 0);   
      Ba                      : IN std_logic_vector(1 DOWNTO 0);   
      Clk0                    : IN std_logic;   
      Clk0_n                  : IN std_logic;   
      Clk1                    : IN std_logic;   
      Clk1_n                  : IN std_logic;   
      Clk2                    : IN std_logic;   
      Clk2_n                  : IN std_logic;   
      Cke0                    : IN std_logic;   
      Cke1                    : IN std_logic;   
      Ras_n                   : IN std_logic;   
      Cas_n                   : IN std_logic;   
      We_n                    : IN std_logic;   
      Dm                      : IN std_logic_vector(7 DOWNTO 0);   
      S0_n                    : IN std_logic;   
      S1_n                    : IN std_logic);   
END COMPONENT;

COMPONENT pcb_delay 
generic (board_delay : time);
port    (A : inout Std_Logic;
         B : inout Std_Logic ); 
END COMPONENT;
					           
  SIGNAL    AD         :  std_logic_vector(63 DOWNTO 0);   
  SIGNAL    CBE        :  std_logic_vector(7 DOWNTO 0);   
  SIGNAL    PAR        :  std_logic;   
  SIGNAL    PAR64      :  std_logic;  
  SIGNAL    FRAME_N    :  std_logic;   
  SIGNAL    REQ64_N    :  std_logic;   
  SIGNAL    TRDY_N     :  std_logic;   
  SIGNAL    IRDY_N     :  std_logic;   
  SIGNAL    STOP_N     :  std_logic;   
  SIGNAL    DEVSEL_N   :  std_logic;   
  SIGNAL    ACK64_N    :  std_logic;   
  SIGNAL    IDSEL      :  std_logic;   
  SIGNAL    INTA_N     : std_logic;   
  SIGNAL    PMEA_N     : std_logic;   
  SIGNAL    PERR_N     : std_logic;     
  SIGNAL    SERR_N     : std_logic;   
  SIGNAL    REQ_N      : std_logic;   
  SIGNAL    GNT_N      :  std_logic;   
  SIGNAL    RST_N      :  std_logic;   
  SIGNAL    CLK        :  std_logic;   
  SIGNAL    FPGA_RTR   :  std_logic;
  SIGNAL    CLK200_N           : std_logic := '0';   
  SIGNAL    CLK200_P           : std_logic := '1';   
  SIGNAL    DDR_DIMM_RAS_L     :  std_logic;   
  SIGNAL    DDR_DIMM_CAS_L     :  std_logic;   
  SIGNAL    DDR_DIMM_WE_L      :  std_logic;   
  SIGNAL    DDR_DIMM_CKE0      :  std_logic;   
  SIGNAL    DDR_DIMM_CKE1      :  std_logic;   
  SIGNAL    DDR_DIMM_CS_N0_7   :  std_logic;   
  SIGNAL    DDR_DIMM_CS_N8_15  :  std_logic;   
  SIGNAL    DDR_DIMM_DQ        :  std_logic_vector(63 DOWNTO 0);   
  SIGNAL    DDR_DIMM_DQS       :  std_logic_vector(7 DOWNTO 0);   
  SIGNAL    DDR_DIMM_CLK0_P    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK0_N    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK1_P    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK1_N    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK2_P    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK2_N    :  std_logic;   
  SIGNAL    DDR_DIMM_BA        :  std_logic_vector(1 DOWNTO 0);   
  SIGNAL    DDR_DIMM_ADDRESS   :  std_logic_vector(11 DOWNTO 0);   
  SIGNAL    DDR_DIMM_SA        :  std_logic_vector(2 DOWNTO 0);   
  SIGNAL    DDR_DIMM_SDA       :  std_logic;   
  SIGNAL    DDR_DIMM_SCL       :  std_logic;   
  SIGNAL    DDR_DIMM_DM        :  std_logic_vector(7 DOWNTO 0);             
  SIGNAL    DDR_DIMM_RAS_L_delay     :  std_logic;   
  SIGNAL    DDR_DIMM_CAS_L_delay     :  std_logic;   
  SIGNAL    DDR_DIMM_WE_L_delay      :  std_logic;   
  SIGNAL    DDR_DIMM_CKE0_delay      :  std_logic;   
  SIGNAL    DDR_DIMM_CKE1_delay      :  std_logic;   
  SIGNAL    DDR_DIMM_CS_N0_7_delay   :  std_logic;   
  SIGNAL    DDR_DIMM_CS_N8_15_delay  :  std_logic;   
  SIGNAL    DDR_DIMM_DQ_delay        :  std_logic_vector(63 DOWNTO 0);   
  SIGNAL    DDR_DIMM_DQS_delay       :  std_logic_vector(7 DOWNTO 0);   
  SIGNAL    DDR_DIMM_CLK0_P_delay    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK0_N_delay    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK1_P_delay    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK1_N_delay    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK2_P_delay    :  std_logic;   
  SIGNAL    DDR_DIMM_CLK2_N_delay    :  std_logic;   
  SIGNAL    DDR_DIMM_BA_delay        :  std_logic_vector(1 DOWNTO 0);   
  SIGNAL    DDR_DIMM_ADDRESS_delay   :  std_logic_vector(11 DOWNTO 0);   
  SIGNAL    DDR_DIMM_SA_delay        :  std_logic_vector(2 DOWNTO 0);   
  SIGNAL    DDR_DIMM_SDA_delay       :  std_logic;   
  SIGNAL    DDR_DIMM_SCL_delay       :  std_logic;   
  SIGNAL    DDR_DIMM_DM_delay        :  std_logic_vector(7 DOWNTO 0);

constant ddr_delay: time := 2.3 ns;

  BEGIN

 DDR_DIMM_RAS_L_delay <= transport DDR_DIMM_RAS_L after ddr_delay;
 DDR_DIMM_CAS_L_delay <= transport DDR_DIMM_CAS_L after ddr_delay;   
 DDR_DIMM_WE_L_delay  <= transport DDR_DIMM_WE_L after ddr_delay;   
 DDR_DIMM_CKE0_delay  <= transport DDR_DIMM_CKE0 after ddr_delay;   
 DDR_DIMM_CKE1_delay  <= transport DDR_DIMM_CKE1 after ddr_delay;   
 DDR_DIMM_CS_N0_7_delay  <= transport DDR_DIMM_CS_N0_7 after ddr_delay;
 DDR_DIMM_CS_N8_15_delay <= transport DDR_DIMM_CS_N8_15 after ddr_delay;

DQ_DELAY:
   for N in 0 to 63 generate
     dq_wire: pcb_delay 
     generic map(board_delay => ddr_delay)
     port map   (A => DDR_DIMM_DQ_delay(N),
                 B => DDR_DIMM_DQ(N)); 
 
   end generate;
DQS_DELAY:
  for N in 0 to 7 generate
     dqs_wire: pcb_delay 
     generic map(board_delay => ddr_delay)
     port map   (A => DDR_DIMM_DQS_delay(N),
                 B => DDR_DIMM_DQS(N)); 
    end generate;
-- DDR_DIMM_DQ_delay   <=  DDR_DIMM_DQ;    
-- DDR_DIMM_DQS_delay  <=  DDR_DIMM_DQS; 
-- DDR_DIMM_DQ   <= transport DDR_DIMM_DQ_delay after 1.2 ns;    
-- DDR_DIMM_DQS  <= DDR_DIMM_DQS_delay after 1.2 ns;     
 DDR_DIMM_CLK0_P_delay <= transport DDR_DIMM_CLK0_P after ddr_delay;  
 DDR_DIMM_CLK0_N_delay <= transport DDR_DIMM_CLK0_N after ddr_delay;  
 DDR_DIMM_CLK1_P_delay <= transport DDR_DIMM_CLK1_P after ddr_delay;  
 DDR_DIMM_CLK1_N_delay <= transport DDR_DIMM_CLK1_N after ddr_delay;  
 DDR_DIMM_CLK2_P_delay <= transport DDR_DIMM_CLK2_P after ddr_delay;  
 DDR_DIMM_CLK2_N_delay <= transport DDR_DIMM_CLK2_N after ddr_delay;  
 DDR_DIMM_BA_delay     <= transport DDR_DIMM_BA after ddr_delay;  
 DDR_DIMM_ADDRESS_delay  <= transport DDR_DIMM_ADDRESS after ddr_delay;
 DDR_DIMM_SA_delay   <= transport DDR_DIMM_SA after ddr_delay;    
 DDR_DIMM_SDA_delay  <= transport DDR_DIMM_SDA after ddr_delay;    
 DDR_DIMM_SCL_delay  <= transport DDR_DIMM_SCL after ddr_delay;    
 DDR_DIMM_DM_delay   <= transport DDR_DIMM_DM after ddr_delay;    

  -- Component Instantiation

   STM: STIMULUS PORT MAP (
      AD           =>   AD,  
      CBE          =>   CBE,  
      PAR          =>   PAR,       
      PAR64        =>   PAR64,     
      FRAME_N      =>   FRAME_N,   
      REQ64_N      =>   REQ64_N,   
      TRDY_N       =>   TRDY_N,    
      IRDY_N       =>   IRDY_N,    
      STOP_N       =>   STOP_N,    
      DEVSEL_N     =>   DEVSEL_N,  
      ACK64_N      =>   ACK64_N,   
      IDSEL        =>   IDSEL,     
      INTA_N       =>   INTA_N,    
      PMEA_N       =>   PMEA_N,    
      PERR_N       =>   PERR_N,    
      SERR_N       =>   SERR_N,    
      REQ_N        =>   REQ_N,     
      GNT_N        =>   GNT_N,     
      RST_N        =>   RST_N,     
      CLK          =>   CLK,       
      FPGA_RTR     =>   FPGA_RTR  
		); 

   UUT: PCIX_TOP PORT MAP(
      AD          =>    AD,    
      CBE         =>    CBE,    
      PAR         =>    PAR,     
      PAR64       =>    PAR64,   
      FRAME_N     =>    FRAME_N, 
      REQ64_N     =>    REQ64_N, 
      TRDY_N      =>    TRDY_N,  
      IRDY_N      =>    IRDY_N,  
      STOP_N      =>    STOP_N,  
      DEVSEL_N    =>    DEVSEL_N,
      ACK64_N     =>    ACK64_N, 
      IDSEL       =>    IDSEL,   
      PERR_N      =>    INTA_N,  
      SERR_N      =>    PMEA_N,  
      INTA_N      =>    PERR_N,  
      PMEA_N      =>    SERR_N,  
      REQ_N       =>    REQ_N,   
      GNT_N       =>    GNT_N,   
      RST_N       =>    RST_N,   
      PCLK        =>    CLK,     
      FPGA_RTR    =>    FPGA_RTR, 
      CLK200_N    =>    CLK200_N,        
      CLK200_P    =>    CLK200_P,        
      DDR_DIMM_RAS_L =>       DDR_DIMM_RAS_L,   
      DDR_DIMM_CAS_L =>       DDR_DIMM_CAS_L,   
      DDR_DIMM_WE_L  =>       DDR_DIMM_WE_L,    
      DDR_DIMM_CKE0  =>       DDR_DIMM_CKE0,    
      DDR_DIMM_CKE1  =>       DDR_DIMM_CKE1,    
      DDR_DIMM_CS_N0_7  =>    DDR_DIMM_CS_N0_7,  
      DDR_DIMM_CS_N8_15  =>   DDR_DIMM_CS_N8_15,  
      DDR_DIMM_DQ        =>   DDR_DIMM_DQ,        
      DDR_DIMM_DQS       =>   DDR_DIMM_DQS,       
      DDR_DIMM_CLK0_P    =>   DDR_DIMM_CLK0_P,    
      DDR_DIMM_CLK0_N    =>   DDR_DIMM_CLK0_N,    
      DDR_DIMM_CLK1_P    =>   DDR_DIMM_CLK1_P,    
      DDR_DIMM_CLK1_N    =>   DDR_DIMM_CLK1_N,    
      DDR_DIMM_CLK2_P    =>   DDR_DIMM_CLK2_P,    
      DDR_DIMM_CLK2_N    =>   DDR_DIMM_CLK2_N,    
      DDR_DIMM_BA        =>   DDR_DIMM_BA,        
      DDR_DIMM_ADDRESS   =>   DDR_DIMM_ADDRESS,   
      DDR_DIMM_SA        =>   DDR_DIMM_SA,        
      DDR_DIMM_SDA       =>   DDR_DIMM_SDA,       
      DDR_DIMM_SCL       =>   DDR_DIMM_SCL,       
      DDR_DIMM_DM        => 	DDR_DIMM_DM        
		);    
		
	U_DIMM: DDR_DIMM  PORT MAP(
      Dq        =>   DDR_DIMM_DQ_delay,      
      Dqs       =>   DDR_DIMM_DQS_delay,      
      Addr      =>   DDR_DIMM_ADDRESS_delay,      
      Ba        =>   DDR_DIMM_BA_delay,      
      Clk0      =>   DDR_DIMM_CLK0_N_delay, 
      Clk0_n    =>   DDR_DIMM_CLK0_P_delay, 
      Clk1      =>   DDR_DIMM_CLK1_N_delay, 
      Clk1_n    =>   DDR_DIMM_CLK1_P_delay, 
      Clk2      =>   DDR_DIMM_CLK2_N_delay, 
      Clk2_n    =>   DDR_DIMM_CLK2_P_delay, 
      Cke0      =>   DDR_DIMM_CKE0_delay,
      Cke1      =>   DDR_DIMM_CKE1_delay,
      Ras_n     =>   DDR_DIMM_RAS_L_delay,
      Cas_n     =>   DDR_DIMM_CAS_L_delay,
      We_n      =>   DDR_DIMM_WE_L_delay, 
      Dm        =>   DDR_DIMM_DM_delay,      
      S0_n      =>   DDR_DIMM_CS_N0_7_delay,       
      S1_n      =>   DDR_DIMM_CS_N8_15_delay );


		
--	U_DIMM: DDR_DIMM  PORT MAP(
--      Dq        =>   DDR_DIMM_DQ,      
--      Dqs       =>   DDR_DIMM_DQS,      
--      Addr      =>   DDR_DIMM_ADDRESS,      
--      Ba        =>   DDR_DIMM_BA,      
--      Clk0      =>   DDR_DIMM_CLK0_N, 
--      Clk0_n    =>   DDR_DIMM_CLK0_P, 
--      Clk1      =>   DDR_DIMM_CLK1_N, 
--      Clk1_n    =>   DDR_DIMM_CLK1_P, 
--      Clk2      =>   DDR_DIMM_CLK2_N, 
--      Clk2_n    =>   DDR_DIMM_CLK2_P, 
--      Cke0      =>   DDR_DIMM_CKE0,
--      Cke1      =>   DDR_DIMM_CKE1,
--      Ras_n     =>   DDR_DIMM_RAS_L,
--      Cas_n     =>   DDR_DIMM_CAS_L,
--      We_n      =>   DDR_DIMM_WE_L, 
--      Dm        =>   DDR_DIMM_DM,      
--      S0_n      =>   DDR_DIMM_CS_N0_7,       
--      S1_n      =>   DDR_DIMM_CS_N8_15 
--	);


  FRAME_N <= 'H';
  REQ64_N <= 'H';
  TRDY_N <= 'H';
  IRDY_N <= 'H';
  STOP_N <= 'H';
  DEVSEL_N <= 'H';
  ACK64_N <= 'H';
  INTA_N <= 'H';
  PMEA_N <= 'H';
  PERR_N <= 'H';
  SERR_N <= 'H';
  REQ_N <= 'H';
  GNT_N <= 'H';
 
  -- Extension pull ups

  PAR64 <= 'H';
  CBE(7 downto 4) <= (others => 'H');
  AD(63 downto 32) <= (others => 'H');

--p1 : pullup port map(o =>	PAR64);
--p2 : pullup port map(o =>	CBE(7));
--p3 : pullup port map(o =>	CBE(6));
--p4 : pullup port map(o =>	CBE(5));
--p5 : pullup port map(o =>	CBE(4));	
--p6 : pullup port map(o =>	AD(63));
--p7 : pullup port map(o =>	AD(62));
--p8 : pullup port map(o =>	AD(61));
--p9 : pullup port map(o =>	AD(60));
--p10 : pullup port map(o =>	AD(59));
--p11 : pullup port map(o =>	AD(58));
--p12 : pullup port map(o =>	AD(57));
--p13 : pullup port map(o =>	AD(56));
--p14 : pullup port map(o =>	AD(55));
--p15 : pullup port map(o =>	AD(54));
--p16 : pullup port map(o =>	AD(53));
--p17 : pullup port map(o =>	AD(52));
--p18 : pullup port map(o =>	AD(51));
--p19 : pullup port map(o =>	AD(50));
--p20 : pullup port map(o =>	AD(49));
--p21 : pullup port map(o =>	AD(48));
--p22 : pullup port map(o =>	AD(47));
--p23 : pullup port map(o =>	AD(46));
--p24 : pullup port map(o =>	AD(45));
--p25 : pullup port map(o =>	AD(44));
--p26 : pullup port map(o =>	AD(43));
--p27 : pullup port map(o =>	AD(42));
--p28 : pullup port map(o =>	AD(41));
--p29 : pullup port map(o =>	AD(40));
--p30 : pullup port map(o =>	AD(39));
--p31 : pullup port map(o =>	AD(38));
--p32 : pullup port map(o =>	AD(37));
--p33 : pullup port map(o =>	AD(36));
--p34 : pullup port map(o =>	AD(35));
--p35 : pullup port map(o =>	AD(34));
--p36 : pullup port map(o =>	AD(33));
--p37 : pullup port map(o =>	AD(32));
 
  --  Test Bench Statements
     tb : PROCESS
     BEGIN
        wait for 100 ns; -- wait until global set/reset completes
		  
     END PROCESS tb;

	  CLK200_N <= not CLK200_N after	2.5 ns;
	  CLK200_P <= not CLK200_P after	2.5 ns;
  --  End Test Bench 

  END;
